/*;  rseg.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl rseg.h\quad\thepage}} */
/*;  $$Date: 1997/02/13 13:19:29 $$  */
/*;  $$Source: /home/sakakiba/96prog/slope/rseg.h,v $$  */


#if !defined(rseg_h)
#define rseg_h

#include <iostream>
#include "geometrc.h"
#include "riverpoint.h"
#include "dlist.h"
#include "dlist.cc"
#include "node.h"

class NodeL;

class Rseg {		             // ƻʬ饹
 protected:
  int n;		             // ƻʬֹ
  NodeL* startNodeLp;		     // ؤΥݥ
  NodeL* endNodeLp;		     // λؤΥݥ
  DList<RiverPoint*> strmpList;	     // ƻؤΥݥ󥿤Υꥹ
  int updownFlag;		     // -1: ή鲼ή
				     //     (ƻؤΥݥ󥿤Υꥹ
				     //     Ͼή鲼ήϿ)
				     //  1: ήή
				     //     (ƻؤΥݥ󥿤Υꥹ
				     //     ϲήήϿ)
  int chaseFlag;		     // -1: ̤  1: ׺
 public:
  Rseg();		             // default constructor
  Rseg(const Rseg& rseg);	     // copy constructor

  ~Rseg();		// destructor
  Rseg& operator=(const Rseg& rseg); // assignment operator

  int Number() { return n; }

  void Number(int nVal) { n = nVal; }
  NodeL* StartNodeLp() { return startNodeLp; }
  void SetStartNodeLp(NodeL* sNodeLp)  { startNodeLp = sNodeLp; }
  NodeL* EndNodeLp()  { return endNodeLp; }
  void SetEndNodeLp(NodeL* eNodeLp)  { endNodeLp = eNodeLp; }
  DList<RiverPoint*>& StrmpList() { return strmpList; }
  void StrmpList(DList<RiverPoint*> rpList) { strmpList = rpList; }
  int UpdownFlag()  { return updownFlag; }
  void UpdownFlag(int updownFlagVal)  { updownFlag = updownFlagVal; }
  int ChaseFlag()  { return chaseFlag; }
  void ChaseFlag(int flagVal)  { chaseFlag = flagVal; }
  void Print(ostream& dst);

};

#endif
 
/*; end of file */
