/*;  temporaryConnect.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.11 $$ {\rhead{\sl temporaryConnect.cc\quad\thepage}} */
/*;  $$Date: 1997/03/06 14:36:05 $$  */
/*;  $$Source: /home/sakakiba/96prog/slope/temporaryConnect.cc,v $$  */

/*
  temporaryConnect.cc
  ήβ³Ȥ򤷤ޤ

  ѥ
  makefile 

  ¹Է
  temporaryConnect ϥǡե̾

  ϥǡեˤϡϥե(2)Ƚϥե(3)
  Υǡե1Ԥ1ǡե̾Ľ񤤤Ƥ
  ()
  NewGridbase.data
  NewRiverData.data
  Connect.data
  NewRiverWithNum.data
  GnuConnect.data

  ϥե <2> (ϳƥǡեν)
  åɤĺϿǡե(() NewGridbase.data)
  (ֹ桢xɸyɸzɸʻxɸʻyɸ)

  ήϩ֤ʻˤʤ褦˰֤Ĵήϩ֤ 
  Ͽǡե(() NewRiverData.data) 
  (Ͻξxɸyɸzɸʻxɸʻyɸ) 

  ϥե <3> (ϳƥǡեν)
  ήξϿǡե(() Connect.data)
  (ֹ桢xɸyɸzɸμѡƻήɤ
  Ƚ̤³³Ƥήֹ)

  ƻξϿǡե(() NewRiverWithNum.data)
  (ֹ桢Ͻξxɸyɸzɸ)

  gnuplot Ѳ³ǡե(() GnuConnect.data)
*/

#include <iomanip>       // changed from *.h on Oct. 11, 2007
#include <iostream>      // changed from *.h on Oct. 11, 2007
#include <sstream>     // changed from strstream.h on Oct. 11, 2007
#include <assert.h>
#include <math.h>
#include "dfstream.h"
#include "geometrc.h"
#include "gtool.h"
#include "grid.h"
#include "grid.cc"
#include "gridpoint.h"
#include "node.h"
#include "rseg.h"
#include "riverelmnt.h"
#include "riverpoint.h"
#include "slist.h"
#include "slist.cc"
#include "dlist.h"
#include "dlist.cc"
#include "boolean.h"
#include "error.h"

const int TOTALFILES = 5; // ɬפȤե
const int BUFFLEN = 512; // Ԥɤ߹ʸ

// const int XMIN = 11000;	// gnuplot ɽ x ɸκǾ
// const int XMAX = 13000;	// gnuplot ɽ x ɸκ
// const int YMIN = 7500;	// gnuplot ɽ y ɸκǾ
// const int YMAX = 10000;	// gnuplot ɽ y ɸκ

const int XMIN = 12000;	// gnuplot ɽ x ɸκǾ
const int XMAX = 13000;	// gnuplot ɽ x ɸκ
const int YMIN = 7000;	// gnuplot ɽ y ɸκǾ
const int YMAX = 9000;	// gnuplot ɽ y ɸκ

// const int XMIN = 0;	// gnuplot ɽ x ɸκǾ
// const int XMAX = 3000;	// gnuplot ɽ x ɸκ
// const int YMIN = 8000;	// gnuplot ɽ y ɸκǾ
// const int YMAX = 11000;	// gnuplot ɽ y ɸκ

// added by iYutaka (Wed Nov  6 13:27:48 2002)
class RivUnit
{
  protected:

    RiverPoint p1;
    RiverPoint p2;
    long nd;

  public:

    RivUnit(void) {}
    RivUnit(RiverPoint aP1, RiverPoint aP2, long aN = 0)
    {
        p1 = aP1; p2 = aP2; nd = aN;
    }

    RiverPoint& p1Ref() { return p1; }
    RiverPoint& p2Ref() { return p2; }
    RiverPoint p1Val() const { return p1; }
    RiverPoint p2Val() const { return p2; }
    long Number() const { return nd; }
    void Number(long aN) { nd = aN; }
};

const char versionString[256] = "ver. 2.0";

// added by iYutaka (Mon Nov 11 11:41:53 2002)
const char* Version(void)
{
    return versionString;
}

// ********************************************************************
Metric AreaG2( // p0, p1, p2 ˤäƹѤ 2 ܤ֤ͤ
              GridPoint3d& p0, GridPoint3d& p1, GridPoint3d& p2
              ) 
{
    // p0, p1, p2 ˤäƹѤ 2 ܤ֤ͤ
    Metric dx1, dx2, dy1, dy2;
    dx1 = p1.x() - p0.x(); dy1 = p1.y() - p0.y();
    dx2 = p2.x() - p0.x(); dy2 = p2.y() - p0.y();
    return (dx1*dy2 - dy1*dx2);
}

// // ********************************************************************
// void
// CalcArea(		// ƥåɤĺѤη׻
//          Grid<GridPoint3d*>& grid, // åɤĺ
//          DList<RiversidePoint0*>& rspList // ƻήꥹ
//          )
// {
//     int rowval = grid.GetRows();
//     int colval = grid.GetCols();
  
//     double areaVal = 0.;
//     for (int i = 0; i < rowval; i++)
//     {
//         for (int j = 0; j < colval; j++)
// 	{
//             if (grid(i, j) != NULL && grid(i, j)->RiverFlag() < 1)
// 	    {
//                 areaVal = 0;
//                 double a1, a2;
//                 if (grid(i - 1, j + 1) != NULL &&
//                     grid(i, j + 1) != NULL && grid(i - 1, j) != NULL)
// 		{
//                     a1 = AreaG2(*grid(i, j), 
//                                 *grid(i, j + 1), *grid(i - 1, j + 1));
//                     a2 = AreaG2(*grid(i, j), 
//                                 *grid(i - 1, j + 1), *grid(i - 1, j));
//                     areaVal = (a1 + a2) / 8.;
// 		}
//                 if (grid(i - 1, j - 1) != NULL &&
//                     grid(i - 1, j) != NULL && grid(i, j - 1) != NULL)
// 		{
//                     a1 = AreaG2(*grid(i, j), 
//                                 *grid(i - 1, j), *grid(i - 1, j - 1));
//                     a2 = AreaG2(*grid(i, j), 
//                                 *grid(i - 1, j - 1), *grid(i, j - 1));
//                     areaVal = areaVal + (a1 + a2) / 8.;
// 		}
//                 if (grid(i + 1, j - 1) != NULL &&
//                     grid(i, j - 1) != NULL && grid(i + 1, j) != NULL)
// 		{
//                     a1 = AreaG2(*grid(i, j), 
//                                 *grid(i, j - 1), *grid(i + 1, j - 1));
//                     a2 = AreaG2(*grid(i, j), 
//                                 *grid(i + 1, j - 1), *grid(i + 1, j));
//                     areaVal = areaVal + (a1 + a2) / 8.;
// 		}
//                 if (grid(i + 1, j + 1) != NULL &&
//                     grid(i + 1, j) != NULL && grid(i, j + 1) != NULL)
// 		{
//                     a1 = AreaG2(*grid(i, j), 
//                                 *grid(i + 1, j), *grid(i + 1, j + 1));
//                     a2 = AreaG2(*grid(i, j), 
//                                 *grid(i + 1, j + 1), *grid(i, j + 1));
//                     areaVal = areaVal + (a1 + a2) / 8.;
// 		}
//                 grid(i, j)->SetArea(areaVal);
// 	    }
// 	}
//     }
  
//     // ƻήϿ줿ꥹȤϿξϡƻ̵֤
//     // ȤơȤ return 
//     // ƻήϿ줿ꥹȤϿ̤ξϥ顼
//     if (rspList.GetCount() == 0) { return; }
//     else if (rspList.GetCount() < 4) { error(); abort(); }
  
//     rspList.ToHead();
//     while (1)
//     {
//         areaVal = 0;
//         RiversidePoint0* rsp = rspList.Get();
//         int mGB = rsp->MGB();
//         int nGB = rsp->NGB();
//         int dmGB = rsp->DownMGB();
//         int dnGB = rsp->DownNGB();
//         int umGB = rsp->UpMGB();
//         int unGB = rsp->UpNGB();

//         int ma11, na11, ma12, na12, ma21, na21, ma22, na22;
//         if ((mGB == -1 && nGB == -1) || (rsp->Gpoint() == NULL)) 
// 	{  // ⤷ʤ  
// 	}
//         else if (umGB == -1 && unGB == -1)
// 	{
//             if (dmGB == mGB - 1 && dnGB == nGB + 1)
// 	    {
//                 ma11 = mGB; na11 = nGB + 1;
//                 ma12 = mGB - 1; na12 = nGB + 1;
//                 ma21 = mGB - 1; na21 = nGB + 1;
//                 ma22 = mGB - 1; na22 = nGB;
// 	    }
//             else if (dmGB == mGB - 1 && dnGB == nGB)
// 	    {
//                 ma11 = mGB - 1; na11 = nGB;
//                 ma12 = mGB - 1; na12 = nGB - 1;
//                 ma21 = mGB - 1; na21 = nGB - 1;
//                 ma22 = mGB; na22 = nGB - 1;
// 	    }
//             else if (dmGB == mGB - 1 && dnGB == nGB - 1)
// 	    {
//                 ma11 = mGB - 1; na11 = nGB;
//                 ma12 = mGB - 1; na12 = nGB - 1;
//                 ma21 = mGB - 1; na21 = nGB - 1;
//                 ma22 = mGB; na22 = nGB - 1;
// 	    }
//             else if (dmGB == mGB && dnGB == nGB - 1)
// 	    {
//                 ma11 = mGB; na11 = nGB - 1;
//                 ma12 = mGB + 1; na12 = nGB - 1;
//                 ma21 = mGB + 1; na21 = nGB - 1;
//                 ma22 = mGB + 1; na22 = nGB;
// 	    }
//             else if (dmGB == mGB + 1 && dnGB == nGB - 1)
// 	    {
//                 ma11 = mGB; na11 = nGB - 1;
//                 ma12 = mGB + 1; na12 = nGB - 1;
//                 ma21 = mGB + 1; na21 = nGB - 1;
//                 ma22 = mGB + 1; na22 = nGB;
// 	    }
//             else if (dmGB == mGB + 1 && dnGB == nGB)
// 	    {
//                 ma11 = mGB + 1; na11 = nGB;
//                 ma12 = mGB + 1; na12 = nGB + 1;
//                 ma21 = mGB + 1; na21 = nGB + 1;
//                 ma22 = mGB; na22 = nGB + 1;
// 	    }
//             else if (dmGB == mGB + 1 && dnGB == nGB + 1)
// 	    {
//                 ma11 = mGB + 1; na11 = nGB;
//                 ma12 = mGB + 1; na12 = nGB + 1;
//                 ma21 = mGB + 1; na21 = nGB + 1;
//                 ma22 = mGB; na22 = nGB + 1;
// 	    }
//             else if (dmGB == mGB && dnGB == nGB + 1)
// 	    {
//                 ma11 = mGB; na11 = nGB + 1;
//                 ma12 = mGB - 1; na12 = nGB + 1;
//                 ma21 = mGB - 1; na21 = nGB + 1;
//                 ma22 = mGB - 1; na22 = nGB;
// 	    }
//             else
// 	    { error(); abort(); }
	  
//             double a1 = 0;
//             double a2 = 0;
//             if (grid(mGB, nGB) != NULL &&
//                 grid(ma11, na11) != NULL && grid(ma12, na12) != NULL)
//                 a1 = AreaG2(*grid(mGB, nGB), 
//                             *grid(ma11, na11), *grid(ma12, na12));
//             if (grid(mGB, nGB) != NULL &&
//                 grid(ma21, na21) != NULL && grid(ma22, na22) != NULL)
//                 a2 = AreaG2(*grid(mGB, nGB), 
//                             *grid(ma21, na21), *grid(ma22, na22));
//             areaVal = (fabs(a1) + fabs(a2)) / 16.;
//             (rsp->Gpoint())->SetArea(areaVal);
//             grid(mGB, nGB)->SetArea(grid(mGB, nGB)->Area() - areaVal);
// 	}
//         else if (dmGB == -1 && dnGB == -1)
// 	{
//             if (umGB == mGB - 1 && unGB == nGB + 1)
// 	    {
//                 ma11 = mGB; na11 = nGB + 1;
//                 ma12 = mGB - 1; na12 = nGB + 1;
//                 ma21 = mGB - 1; na21 = nGB + 1;
//                 ma22 = mGB - 1; na22 = nGB;
// 	    }
//             else if (umGB == mGB - 1 && unGB == nGB)
// 	    {
//                 ma11 = mGB; na11 = nGB + 1;
//                 ma12 = mGB - 1; na12 = nGB + 1;
//                 ma21 = mGB - 1; na21 = nGB + 1;
//                 ma22 = mGB - 1; na22 = nGB;
// 	    }
//             else if (umGB == mGB - 1 && unGB == nGB - 1)
// 	    {
//                 ma11 = mGB - 1; na11 = nGB;
//                 ma12 = mGB - 1; na12 = nGB - 1;
//                 ma21 = mGB - 1; na21 = nGB - 1;
//                 ma22 = mGB; na22 = nGB - 1;
// 	    }
//             else if (umGB == mGB && unGB == nGB - 1)
// 	    {
//                 ma11 = mGB - 1; na11 = nGB;
//                 ma12 = mGB - 1; na12 = nGB - 1;
//                 ma21 = mGB - 1; na21 = nGB - 1;
//                 ma22 = mGB; na22 = nGB - 1;
// 	    }
//             else if (umGB == mGB + 1 && unGB == nGB - 1)
// 	    {
//                 ma11 = mGB; na11 = nGB - 1;
//                 ma12 = mGB + 1; na12 = nGB - 1;
//                 ma21 = mGB + 1; na21 = nGB - 1;
//                 ma22 = mGB + 1; na22 = nGB;
// 	    }
//             else if (umGB == mGB + 1 && unGB == nGB)
// 	    {
//                 ma11 = mGB; na11 = nGB - 1;
//                 ma12 = mGB - 1; na12 = nGB - 1;
//                 ma21 = mGB - 1; na21 = nGB - 1;
//                 ma22 = mGB + 1; na22 = nGB;
// 	    }
//             else if (umGB == mGB + 1 && unGB == nGB + 1)
// 	    {
//                 ma11 = mGB + 1; na11 = nGB;
//                 ma12 = mGB + 1; na12 = nGB + 1;
//                 ma21 = mGB + 1; na21 = nGB + 1;
//                 ma22 = mGB; na22 = nGB + 1;
// 	    }
//             else if (umGB == mGB && unGB == nGB + 1)
// 	    {
//                 ma11 = mGB + 1; na11 = nGB;
//                 ma12 = mGB + 1; na12 = nGB + 1;
//                 ma21 = mGB + 1; na21 = nGB + 1;
//                 ma22 = mGB; na22 = nGB + 1;
// 	    }
//             else
// 	    { error(); abort(); }

//             double a1 = 0;
//             double a2 = 0;
//             if (grid(mGB, nGB) != NULL &&
//                 grid(ma11, na11) != NULL && grid(ma12, na12) != NULL)
//                 a1 = AreaG2(*grid(mGB, nGB), 
//                             *grid(ma11, na11), *grid(ma12, na12));
//             if (grid(mGB, nGB) != NULL &&
//                 grid(ma21, na21) != NULL && grid(ma22, na22) != NULL)
//                 a2 = AreaG2(*grid(mGB, nGB), 
//                             *grid(ma21, na21), *grid(ma22, na22));
//             areaVal = (fabs(a1) + fabs(a2)) / 16.;
//             (rsp->Gpoint())->SetArea(areaVal);
//             grid(mGB, nGB)->SetArea(grid(mGB, nGB)->Area() - areaVal);
// 	}
//         else
// 	{
//             int mval = umGB; int nval = unGB;
//             while (1)
// 	    {

//                 if (mval == mGB - 1 && nval == nGB + 1)
// 		{ 
//                     mval = mGB; nval = nGB + 1;
		  
//                     ma11 = mGB; na11 = nGB + 1;
//                     ma12 = mGB - 1; na12 = nGB + 1;
//                     ma21 = mGB - 1; na21 = nGB + 1;
//                     ma22 = mGB - 1; na22 = nGB;
// 		}
//                 else if (mval == mGB - 1 && nval == nGB)
// 		{ 
//                     mval = mGB - 1; nval = nGB + 1;
		  
//                     ma11 = mGB; na11 = nGB + 1;
//                     ma12 = mGB - 1; na12 = nGB + 1;
//                     ma21 = mGB - 1; na21 = nGB + 1;
//                     ma22 = mGB - 1; na22 = nGB;
// 		}
//                 else if (mval == mGB - 1 && nval == nGB - 1)
// 		{ 
//                     mval = mGB - 1; nval = nGB;
		  
//                     ma11 = mGB - 1; na11 = nGB;
//                     ma12 = mGB - 1; na12 = nGB - 1;
//                     ma21 = mGB - 1; na21 = nGB - 1;
//                     ma22 = mGB; na22 = nGB - 1;
// 		}
//                 else if (mval == mGB && nval == nGB - 1)
// 		{ 
//                     mval = mGB - 1; nval = nGB - 1;
		  
//                     ma11 = mGB - 1; na11 = nGB;
//                     ma12 = mGB - 1; na12 = nGB - 1;
//                     ma21 = mGB - 1; na21 = nGB - 1;
//                     ma22 = mGB; na22 = nGB - 1;
// 		}
//                 else if (mval == mGB + 1 && nval == nGB - 1)
// 		{ 
//                     mval = mGB; nval = nGB - 1;
		  
//                     ma11 = mGB; na11 = nGB - 1;
//                     ma12 = mGB + 1; na12 = nGB - 1;
//                     ma21 = mGB + 1; na21 = nGB - 1;
//                     ma22 = mGB + 1; na22 = nGB;
// 		}
//                 else if (mval == mGB + 1 && nval == nGB)
// 		{ 
//                     mval = mGB + 1; nval = nGB - 1;
		  
//                     ma11 = mGB; na11 = nGB - 1;
//                     ma12 = mGB + 1; na12 = nGB - 1;
//                     ma21 = mGB + 1; na21 = nGB - 1;
//                     ma22 = mGB + 1; na22 = nGB;
// 		}
//                 else if (mval == mGB + 1 && nval == nGB + 1)
// 		{ 
//                     mval = mGB + 1; nval = nGB;
		  
//                     ma11 = mGB + 1; na11 = nGB;
//                     ma12 = mGB + 1; na12 = nGB + 1;
//                     ma21 = mGB + 1; na21 = nGB + 1;
//                     ma22 = mGB; na22 = nGB + 1;
// 		}
//                 else if (mval == mGB && nval == nGB + 1)
// 		{ 
//                     mval = mGB + 1; nval = nGB + 1;
		  
//                     ma11 = mGB + 1; na11 = nGB;
//                     ma12 = mGB + 1; na12 = nGB + 1;
//                     ma21 = mGB + 1; na21 = nGB + 1;
//                     ma22 = mGB; na22 = nGB + 1;
// 		}
//                 else
// 		{ error(); abort(); }
	      
//                 double a1 = 0;
//                 double a2 = 0;
//                 if (grid(mGB, nGB) != NULL &&
//                     grid(ma11, na11) != NULL && grid(ma12, na12) != NULL)
//                     a1 = AreaG2(*grid(mGB, nGB), 
//                                 *grid(ma11, na11), *grid(ma12, na12));
//                 if (grid(mGB, nGB) != NULL &&
//                     grid(ma21, na21) != NULL && grid(ma22, na22) != NULL)
//                     a2 = AreaG2(*grid(mGB, nGB), 
//                                 *grid(ma21, na21), *grid(ma22, na22));
//                 areaVal = areaVal + (a1 + a2) / 16.;

//                 if (dmGB == mval && dnGB == nval) break;
// 	    }
//             (rsp->Gpoint())->SetArea(areaVal);
// 	}

//         if (rspList.ToNext() == NO) break;
//     } 
//     return;
// }


// ********************************************************************
// ƥåɤĺѤη׻
void
CalcArea
(
 Grid<GridPoint3d*>& grid,         // åɤĺ
 DList<RiversidePoint0*>& rspList, // ƻήꥹ
 DList<NodeL*>& aNodeList          // ƻüΥꥹ
)
{
    int rowval = grid.GetRows();
    int colval = grid.GetCols();

    double areaVal = 0.;
    for (int i = 0; i < rowval; i++)
    {
        for (int j = 0; j < colval; j++)
	{
            if (grid(i, j) == NULL) continue;

            areaVal = 0.0;
            double a1, a2;
            if (grid(i - 1, j + 1) != NULL &&
                grid(i, j + 1) != NULL && grid(i - 1, j) != NULL)
            {
                a1 = AreaG2(*grid(i, j), 
                            *grid(i, j + 1), *grid(i - 1, j + 1));
                a2 = AreaG2(*grid(i, j), 
                            *grid(i - 1, j + 1), *grid(i - 1, j));
                areaVal = (a1 + a2) / 8.;
            }
            if (grid(i - 1, j - 1) != NULL &&
                grid(i - 1, j) != NULL && grid(i, j - 1) != NULL)
            {
                a1 = AreaG2(*grid(i, j), 
                            *grid(i - 1, j), *grid(i - 1, j - 1));
                a2 = AreaG2(*grid(i, j), 
                            *grid(i - 1, j - 1), *grid(i, j - 1));
                areaVal = areaVal + (a1 + a2) / 8.;
            }
            if (grid(i + 1, j - 1) != NULL &&
                grid(i, j - 1) != NULL && grid(i + 1, j) != NULL)
            {
                a1 = AreaG2(*grid(i, j), 
                            *grid(i, j - 1), *grid(i + 1, j - 1));
                a2 = AreaG2(*grid(i, j), 
                            *grid(i + 1, j - 1), *grid(i + 1, j));
                areaVal = areaVal + (a1 + a2) / 8.;
            }
            if (grid(i + 1, j + 1) != NULL &&
                grid(i + 1, j) != NULL && grid(i, j + 1) != NULL)
            {
                a1 = AreaG2(*grid(i, j), 
                            *grid(i + 1, j), *grid(i + 1, j + 1));
                a2 = AreaG2(*grid(i, j), 
                            *grid(i + 1, j + 1), *grid(i, j + 1));
                areaVal = areaVal + (a1 + a2) / 8.;
            }
            grid(i, j)->SetArea(areaVal);
	}
    }
  
    // ƻήϿ줿ꥹȤϿ 0 ξϡƻ̵֤
    // ȤơȤ return 
    // ƻήϿ줿ꥹȤϿ 4 ̤ξϥ顼
    if (rspList.GetCount() == 0) { return; }
    else if (rspList.GetCount() < 4) { error(); abort(); }
  
    rspList.ToHead();
    while (1)
    {
        RiversidePoint0* rsp = rspList.Get();
        int mGB = rsp->MGB();
        int nGB = rsp->NGB();
        int dmGB = rsp->DownMGB();
        int dnGB = rsp->DownNGB();
        int umGB = rsp->UpMGB();
        int unGB = rsp->UpNGB();

        // rsp  sentinel ʤΤǲ⤷ʤ  
        if ((mGB == -1 && nGB == -1) || (rsp->Gpoint() == NULL)) 
	{
	}
        // rsp üʤΤǡ³ƤƻʬοĴ٤
        else if ((umGB == -1 && unGB == -1) || (dmGB == -1 && dnGB == -1))
        {
            // üΥꥹȤ rsp Ȱפüõ
            aNodeList.ToHead();
            for (Boolean r = YES; r != NO; r = aNodeList.ToNext())
            {
                NodeL* tmpnode = aNodeList.Get();

                // rsp Ȱפüȯ
                if (mGB == tmpnode->MGB() && nGB == tmpnode->NGB())
                {
                    // ü³Ƥƻʬο
                    int numriver = tmpnode->GetCount();

                    // grid(mGB, nGB)äƤѤ numriver*2 ʬ
                    // (ƻήο = numriver*2)
                    double area = grid(mGB, nGB)->Area() / (numriver*2);

                    // ʬΤ rsp ѤȤƳ꿶
                    (rsp->Gpoint())->SetArea(area);

                    break;
                }
            }
        }
        // ƻ
        else
        {
            // grid(mGB, nGB)ѤФ
            double area = grid(mGB, nGB)->Area();
            
            // ƻ֤Ƥƻή2ĤʤΤ0.5򤫤
            (rsp->Gpoint())->SetArea(area*0.5);
        }

        if (rspList.ToNext() == NO) break;
    } 

    // Ǹ˲ƻή֤ƤʻѤ0ˤ
    rspList.ToHead();
    for (Boolean r = YES; r != NO; r = rspList.ToNext())
    {
        RiversidePoint0* rsp = rspList.Get();
        if (rsp->Gpoint() == NULL) continue;

        int mGB = rsp->MGB();
        int nGB = rsp->NGB();
        grid(mGB, nGB)->SetArea(0.0);
    }

    return;
}


// ********************************************************************
void
Connect(		// ܤƻήƱΤ³
        GridPoint3d* gp,	// ƻή
        DList<RiversidePoint0*>& rspList, // ƻήꥹ
        int mGB, int nGB,	// ƻήγʻҺɸ
        int nmval, int nnval	// ܤƻήγʻҺɸ
        )
{
    rspList.ToHead();
    while (1)
    {
        RiversidePoint0* searchrsp = rspList.Get();
        if (searchrsp->MGB() == nmval && searchrsp->NGB() == nnval)
	{
            int mval = searchrsp->UpMGB();
            int nval = searchrsp->UpNGB();
            int dmval = searchrsp->DownMGB();
            int dnval = searchrsp->DownNGB();
            Boolean foundFlag = NO;
            while (1)
	    {
                if (mval == nmval - 1 && nval == nnval + 1)
		{ mval = nmval; nval = nnval + 1; }
                else if (mval == nmval - 1 && nval == nnval)
		{ mval = nmval - 1; nval = nnval + 1; }
                else if (mval == nmval - 1 && nval == nnval - 1)
		{ mval = nmval - 1; nval = nnval; }
                else if (mval == nmval && nval == nnval - 1)
		{ mval = nmval - 1; nval = nnval - 1; }
                else if (mval == nmval + 1 && nval == nnval - 1)
		{ mval = nmval; nval = nnval - 1; }
                else if (mval == nmval + 1 && nval == nnval)
		{ mval = nmval + 1; nval = nnval - 1; }
                else if (mval == nmval + 1 && nval == nnval + 1)
		{ mval = nmval + 1; nval = nnval; }
                else if (mval == nmval && nval == nnval + 1)
		{ mval = nmval + 1; nval = nnval + 1; }
                else
		{ error(); abort(); }

                if (mval == mGB && nval == nGB)
		{
                    gp->ConnectGp(searchrsp->Gpoint());
                    foundFlag = YES;
                    break;
		}
                else if (mval == dmval && nval == dnval) break;
	    }

            if (foundFlag == YES) break;
	}
        if (rspList.ToNext() == NO) { error(); abort(); }
    }

    return;
}

// ********************************************************************
void
CutConnect(		// ƻβ³
           GridPoint3d* gp,	// ƻxyɸƱͤĥåɤĺ
           DList<RiversidePoint0*>& rspList, // ƻήꥹ
           int mGB, int nGB,	// ƻήγʻҺɸ
           int nmval, int nnval	// ܤƻήγʻҺɸ
           )
{
    rspList.ToHead();
    while (1)
    {
        RiversidePoint0* searchrsp = rspList.Get();
        if (searchrsp->MGB() == nmval && searchrsp->NGB() == nnval)
	{
            int mval = searchrsp->UpMGB();
            int nval = searchrsp->UpNGB();
            int dmval = searchrsp->DownMGB();
            int dnval = searchrsp->DownNGB();
            Boolean foundFlag = NO;
            while (1)
	    {
                if (mval == nmval - 1 && nval == nnval + 1)
		{ mval = nmval; nval = nnval + 1; }
                else if (mval == nmval - 1 && nval == nnval)
		{ mval = nmval - 1; nval = nnval + 1; }
                else if (mval == nmval - 1 && nval == nnval - 1)
		{ mval = nmval - 1; nval = nnval; }
                else if (mval == nmval && nval == nnval - 1)
		{ mval = nmval - 1; nval = nnval - 1; }
                else if (mval == nmval + 1 && nval == nnval - 1)
		{ mval = nmval; nval = nnval - 1; }
                else if (mval == nmval + 1 && nval == nnval)
		{ mval = nmval + 1; nval = nnval - 1; }
                else if (mval == nmval + 1 && nval == nnval + 1)
		{ mval = nmval + 1; nval = nnval; }
                else if (mval == nmval && nval == nnval + 1)
		{ mval = nmval + 1; nval = nnval + 1; }
                else
		{ error(); abort(); }

                if (mval == mGB && nval == nGB)
		{
                    gp->CutGp(searchrsp->Gpoint());
                    (searchrsp->Gpoint())->CutGp(gp);
                    foundFlag = YES;
                    break;
		}
                else if (mval == dmval && nval == dnval) break;
	    }

            if (foundFlag == YES) break;
	}
        if (rspList.ToNext() == NO) { error(); abort(); }
    }

    return;
}

// // ********************************************************************
// void
// CntRiversideGp(		// ƻήβ³
//                Grid<GridPoint3d*>& grid, // åɤĺ
//                DList<RiversidePoint0*>& rspList // ƻήꥹ
//                )
// {
//     // ƻήϿ줿ꥹȤϿ0ξϡƻ̵֤
//     // ȤơȤ return 
//     // ƻήϿ줿ꥹȤϿ4̤ξϥ顼
//     if (rspList.GetCount() == 0) { return; }
//     else if (rspList.GetCount() < 4) { error(); abort(); }
  
//     // ƻή¾ή³
//     rspList.ToHead();
//     RiversidePoint0* prevrsp = rspList.Get();
//     rspList.ToHead();
//     while (1)
//     {
//         RiversidePoint0* rsp = rspList.Get();
//         int mGB = rsp->MGB();
//         int nGB = rsp->NGB();
//         int dmGB = rsp->DownMGB();
//         int dnGB = rsp->DownNGB();
//         int umGB = rsp->UpMGB();
//         int unGB = rsp->UpNGB();
//         int smGB, snGB, emGB, enGB;
//         GridPoint3d* gp;

//         if (mGB != -1 && nGB != -1)
//         {
//             if (dmGB == -1 && dnGB == -1)
//             {
//                 smGB = umGB; snGB = unGB; emGB = umGB; enGB = unGB;
//                 gp = grid(mGB, nGB);
//             }
//             else if (umGB == -1 && unGB == -1)
//             {
//                 smGB = dmGB; snGB = dnGB; emGB = dmGB; enGB = dnGB;
//                 gp = grid(mGB, nGB);
//             }
//             else
//             {
//                 smGB = umGB; snGB = unGB; emGB = dmGB; enGB = dnGB;
//                 gp = rsp->Gpoint();
//             }
	  
//             int mval, nval, caseVal;
//             Boolean cflag = NO;
//             if (smGB == mGB - 1 && snGB == nGB + 1)
//             { mval = mGB; nval = nGB + 1; caseVal = 8; cflag = YES;}
//             else if (smGB == mGB - 1 && snGB == nGB)
//             { mval = mGB - 1; nval = nGB + 1; caseVal = 1; }
//             else if (smGB == mGB - 1 && snGB == nGB - 1)
//             { mval = mGB - 1; nval = nGB; caseVal = 2; cflag = YES;}
//             else if (smGB == mGB && snGB == nGB - 1)
//             { mval = mGB - 1; nval = nGB - 1; caseVal = 3; }
//             else if (smGB == mGB + 1 && snGB == nGB - 1)
//             { mval = mGB; nval = nGB - 1; caseVal = 4; cflag = YES;}
//             else if (smGB == mGB + 1 && snGB == nGB)
//             { mval = mGB + 1; nval = nGB - 1; caseVal = 5; }
//             else if (smGB == mGB + 1 && snGB == nGB + 1)
//             { mval = mGB + 1; nval = nGB; caseVal = 6; cflag = YES;}
//             else if (smGB == mGB && snGB == nGB + 1)
//             { mval = mGB + 1; nval = nGB + 1; caseVal = 7; }
//             else
//             { error(); abort(); }

//             if (mval != emGB || nval != enGB)
//             {
//                 Boolean flag = NO;
//                 Boolean nflag = NO;
//                 //  m[2], n[2]
//                 // ̤ή¸ߤʤ졢
//                 // ή¸ߤб
//                 int m[3], n[3];
//                 int c = 0;
//                 while (1)
//                 {
//                     if (grid(mval, nval) != NULL)
//                     {
//                         int rivflag = grid(mval, nval)->RiverFlag();
//                         // åɤĺ˲ƻ
//                         if (rivflag > 0)
//                         {
//                             Connect(gp, rspList, mGB, nGB, mval, nval);
//                             rspList.ToHead();
//                             while (1)
//                             {
//                                 if (rsp == rspList.Get()) break;
//                                 if (rspList.ToNext() == NO)
//                                 { error(); abort(); }
//                             }
//                         }
//                         else if (rivflag <= 0)
//                         {
//                             gp->ConnectGp(grid(mval, nval));
//                             grid(mval, nval)->ConnectGp(gp);
//                         }
//                         else
//                         { error(); abort(); }

//                         if (cflag == YES)
//                             flag = YES; 
//                         else
//                         { m[c] = mval; n[c] = nval; c++; }
//                     }
//                     else
//                         nflag = YES;

//                     switch (caseVal)
//                     {
//                     case 1:	// 
//                         mval++; caseVal = 8; cflag = YES; break;
//                     case 2:	// 
//                         nval++; caseVal = 1; cflag = NO; break;
//                     case 3:	// 
//                         nval++; caseVal = 2; cflag = YES; break;
// 		    case 4:	// 
//                         mval--; caseVal = 3; cflag = NO; break;
// 		    case 5:	// 
//                         mval--; caseVal = 4; cflag = YES; break;
// 		    case 6:	// 
//                         nval--; caseVal = 5; cflag = NO; break;
// 		    case 7:	// 
//                         nval--; caseVal = 6; cflag = YES; break;
// 		    case 8:	// 
//                         mval++; caseVal = 7; cflag = NO; break;
// 		    }
		  
//                     if (emGB == mval && enGB == nval) { break; }
// 		}
	      
//                 if (flag == NO && nflag == YES)
// 		{
//                     if (gp == grid(mGB, nGB))
// 		    { error(); abort(); }
//                     for (int ic = 0; ic < c; ic++)
// 		    {
//                         gp->CutGp(grid(m[ic], n[ic]));
//                         grid(m[ic], n[ic])->CutGp(gp);
// 		    }
//                     rsp->SetGpNull();
// 		}
// 	    }

//             // v ˲ƻפ³
//             if ((prevrsp->MGB() != -1 && prevrsp->NGB() != -1) &&
//                 (prevrsp->DownMGB() != -1 && prevrsp->DownNGB() != -1))
// 	    {
//                 int pmGB = prevrsp->MGB();
//                 int pnGB = prevrsp->NGB();
//                 int pdmGB = prevrsp->DownMGB();
//                 int pdnGB = prevrsp->DownNGB();
//                 if ((pmGB == mGB - 1 && pnGB == nGB - 1) &&
//                     (pdmGB == mGB && pdnGB == nGB - 1))
// 		{
//                     if (rspList.ToPrev() == NO)
// 		    { error(); abort(); }
//                     if (rspList.ToPrev() == NO)
// 		    { error(); abort(); }

//                     RiversidePoint0* objrsp = rspList.Get();
//                     if (objrsp->MGB() != pdmGB || objrsp->NGB() != pdnGB)
// 		    { error(); abort(); }
//                     GridPoint3d* objgp = objrsp->Gpoint();
//                     int rivflag = grid(mGB - 1, nGB)->RiverFlag();
//                     if (rivflag > 0)
// 		    {
//                         CutConnect(objgp, rspList, 
//                                    pdmGB, pdnGB, mGB - 1, nGB);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else if (rivflag <= 0)
// 		    {
//                         objgp->CutGp(grid(mGB - 1, nGB));
//                         grid(mGB - 1, nGB)->CutGp(objgp);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else
// 		    { error(); abort(); }
// 		}
//                 else if ((pmGB == mGB && pnGB == nGB - 1) &&
//                          (pdmGB == mGB + 1 && pdnGB == nGB))
// 		{
//                     GridPoint3d* objgp = rsp->Gpoint();
//                     int rivflag = grid(mGB + 1, nGB - 1)->RiverFlag();
//                     if (rivflag > 0)
// 		    {
//                         CutConnect(objgp, rspList, 
//                                    mGB, nGB, mGB + 1, nGB - 1);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else if (rivflag <= 0)
// 		    {
//                         objgp->CutGp(grid(mGB + 1, nGB - 1));
//                         grid(mGB + 1, nGB - 1)->CutGp(objgp);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else
// 		    { error(); abort(); }
// 		}
//                 else if ((pmGB == mGB + 1 && pnGB == nGB - 1) &&
//                          (pdmGB == mGB + 1 && pdnGB == nGB))
// 		{
//                     if (rspList.ToPrev() == NO)
// 		    { error(); abort(); }
//                     if (rspList.ToPrev() == NO)
// 		    { error(); abort(); }

//                     RiversidePoint0* objrsp = rspList.Get();
//                     if (objrsp->MGB() != pdmGB || objrsp->NGB() != pdnGB)
// 		    { error(); abort(); }
//                     GridPoint3d* objgp = objrsp->Gpoint();
//                     int rivflag = grid(mGB, nGB - 1)->RiverFlag();
//                     if (rivflag > 0)
// 		    {
//                         CutConnect(objgp, rspList, 
//                                    pdmGB, pdnGB, mGB, nGB - 1);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else if (rivflag <= 0)
// 		    {
//                         objgp->CutGp(grid(mGB, nGB - 1));
//                         grid(mGB, nGB - 1)->CutGp(objgp);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else
// 		    { error(); abort(); }
// 		}
//                 else if ((pmGB == mGB + 1 && pnGB == nGB) &&
//                          (pdmGB == mGB && pdnGB == nGB + 1))
// 		{
//                     GridPoint3d* objgp = rsp->Gpoint();
//                     int rivflag = grid(mGB + 1, nGB + 1)->RiverFlag();
//                     if (rivflag > 0)
// 		    {
//                         CutConnect(objgp, rspList, 
//                                    mGB, nGB, mGB + 1, nGB + 1);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else if (rivflag <= 0)
// 		    {
//                         objgp->CutGp(grid(mGB + 1, nGB + 1));
//                         grid(mGB + 1, nGB + 1)->CutGp(objgp);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else
// 		    { error(); abort(); }
// 		}
//                 else if ((pmGB == mGB + 1 && pnGB == nGB + 1) &&
//                          (pdmGB == mGB && pdnGB == nGB + 1))
// 		{
//                     if (rspList.ToPrev() == NO)
// 		    { error(); abort(); }
//                     if (rspList.ToPrev() == NO)
// 		    { error(); abort(); }

//                     RiversidePoint0* objrsp = rspList.Get();
//                     if (objrsp->MGB() != pdmGB || objrsp->NGB() != pdnGB)
// 		    { error(); abort(); }
//                     GridPoint3d* objgp = objrsp->Gpoint();
//                     int rivflag = grid(mGB + 1, nGB)->RiverFlag();
//                     if (rivflag > 0)
// 		    {
//                         CutConnect(objgp, rspList, 
//                                    pdmGB, pdnGB, mGB + 1, nGB);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else if (rivflag <= 0)
// 		    {
//                         objgp->CutGp(grid(mGB + 1, nGB));
//                         grid(mGB + 1, nGB)->CutGp(objgp);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else
// 		    { error(); abort(); }
// 		}
//                 else if ((pmGB == mGB && pnGB == nGB + 1) &&
//                          (pdmGB == mGB - 1 && pdnGB == nGB))
// 		{
//                     GridPoint3d* objgp = rsp->Gpoint();
//                     int rivflag = grid(mGB - 1, nGB + 1)->RiverFlag();
//                     if (rivflag > 0)
// 		    {
//                         CutConnect(objgp, rspList, 
//                                    mGB, nGB, mGB - 1, nGB + 1);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else if (rivflag <= 0)
// 		    {
//                         objgp->CutGp(grid(mGB - 1, nGB + 1));
//                         grid(mGB - 1, nGB + 1)->CutGp(objgp);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else
// 		    { error(); abort(); }
// 		}
//                 else if ((pmGB == mGB - 1 && pnGB == nGB) &&
//                          (pdmGB == mGB && pdnGB == nGB - 1))
// 		{
//                     GridPoint3d* objgp = rsp->Gpoint();
//                     int rivflag = grid(mGB - 1, nGB - 1)->RiverFlag();
//                     if (rivflag > 0)
// 		    {
//                         CutConnect(objgp, rspList, 
//                                    mGB, nGB, mGB - 1, nGB - 1);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else if (rivflag <= 0)
// 		    {
//                         objgp->CutGp(grid(mGB - 1, nGB - 1));
//                         grid(mGB - 1, nGB - 1)->CutGp(objgp);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else
// 		    { error(); abort(); }
// 		}
//                 else if ((pmGB == mGB - 1 && pnGB == nGB + 1) &&
//                          (pdmGB == mGB - 1 && pdnGB == nGB))
// 		{
//                     if (rspList.ToPrev() == NO)
// 		    { error(); abort(); }
//                     if (rspList.ToPrev() == NO)
// 		    { error(); abort(); }

//                     RiversidePoint0* objrsp = rspList.Get();
//                     if (objrsp->MGB() != pdmGB || objrsp->NGB() != pdnGB)
// 		    { error(); abort(); }
//                     GridPoint3d* objgp = objrsp->Gpoint();
//                     int rivflag = grid(mGB, nGB + 1)->RiverFlag();
//                     if (rivflag > 0)
// 		    {
//                         CutConnect(objgp, rspList, 
//                                    pdmGB, pdnGB, mGB, nGB + 1);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else if (rivflag <= 0)
// 		    {
//                         objgp->CutGp(grid(mGB, nGB + 1));
//                         grid(mGB, nGB + 1)->CutGp(objgp);
//                         rspList.ToHead();
//                         while (1)
// 			{
//                             if (rsp == rspList.Get()) break;
//                             if (rspList.ToNext() == NO)
// 			    { error(); abort(); }
// 			}
// 		    }
//                     else
// 		    { error(); abort(); }
// 		}
// 	    }
// 	}
//         prevrsp = rsp;
//         if (rspList.ToNext() == NO) break;
//     }

//     // ή貣ƻƱΤβ³
//     rspList.ToHead();
//     while (1)
//     {
//         RiversidePoint0* rsp = rspList.Get();
//         int dmGB = rsp->DownMGB();
//         int dnGB = rsp->DownNGB();
//         int umGB = rsp->UpMGB();
//         int unGB = rsp->UpNGB();

//         // ƻ֤ζڤǤϤʤή貣ƻ¸ߤ
//         if ((rsp->MGB() != -1 && rsp->NGB() != -1) &&
//             rsp->Gpoint() != NULL)
// 	{
//             // ¦
//             if (umGB > -1 && unGB > -1)
// 	    {
//                 if (rspList.ToNext() == YES)
// 		{
//                     RiversidePoint0* nextrsp = rspList.Get();
		  
//                     if (umGB != nextrsp->MGB() && unGB !=
//                         nextrsp->NGB())
// 		    { error(); abort(); }
		  
//                     if (nextrsp->Gpoint() != NULL)
// 		    {
//                         (rsp->Gpoint())->ConnectGp(nextrsp->Gpoint());
// 		    }
		  
//                     if (nextrsp->Gpoint() == NULL && 
//                         (dmGB == -1 && dnGB == -1))
//                         rsp->SetGpNull();
		  
//                     if (rspList.ToPrev() == NO) { error(); abort(); }
// 		}
//                 else
// 		{ error(); abort(); }
// 	    }
//             // ¦
//             if (dmGB > -1 && dnGB > -1)
// 	    {
//                 if (rspList.ToPrev() == YES)
// 		{
//                     RiversidePoint0* prevrsp = rspList.Get();

//                     if (dmGB != prevrsp->MGB() && dnGB !=
//                         prevrsp->NGB())
// 		    { error(); abort(); }
		  
//                     if (prevrsp->Gpoint() != NULL)
// 		    {
//                         (rsp->Gpoint())->ConnectGp(prevrsp->Gpoint());
// 		    }
		  
//                     if (prevrsp->Gpoint() == NULL && 
//                         (umGB == -1 && unGB == -1))
//                         rsp->SetGpNull();
		  
//                     if (rspList.ToNext() == NO) { error(); abort(); }
// 		}
//                 else
// 		{ error(); abort(); }
// 	    }
// 	}
//         if (rspList.ToNext() == NO) break;
//     }
//     return;
// }

// ********************************************************************
// mod. by iYutaka (Sat Nov  2 20:50:06 2002)
// ƻή̤ή³
void
CntRiversideGp
(
 Grid<GridPoint3d*>& grid, // åɤĺ
 DList<RiversidePoint0*>& rspList, // ƻήꥹ
 DList<RivUnit*>& rivunitl // ƻ˥åȤΥꥹ
)
{
    // ƻήϿ줿ꥹȤϿ0ξϡƻ̵֤
    // ȤơȤ return 
    if (rspList.GetCount() == 0) { return; }

    // ƻήο 4 İʾʤФʤʤ
    if (rspList.GetCount() <= 3)
    {
        error();
        abort();
    }

    // ƻήϿƤ֤򼨤եå
    // -1:ήή, 1:ήή
    int updownflag;

    long rlflag = 0; // ʤ麸¦ƻή, ʤ鱦¦ƻή
                     // rspList ˤϡ, , , ν˲ƻή
                     // ϿƤ

    int mGB, nGB;
    int umGB, unGB;
    int dmGB, dnGB;
    GridPoint3d* gp;
    //?
    Boolean udflag;    // ή¦Ȳή¦פ YES ˤ
                       // ϤꤨʤϤ,бƤ
                       // ⤷פƤ顢¦³ȤԤʤ

    rspList.ToHead();
    for (Boolean r = YES; r != NO; r = rspList.ToNext(), rlflag++)
    {
        // ƻήļФ
        RiversidePoint0* rsp = rspList.Get();

        // rsp  sentinel ʤпƻʬϤޤΤǡupdownflag 
        // ꤹ
        if (rsp->Gpoint() == NULL)
        {
            rspList.ToNext();   // Ŀʤ
            RiversidePoint0* rsptmp = rspList.Get(); // ǤФ
            if (rsptmp->UpMGB() == -1) updownflag = -1;
            else if (rsptmp->DownMGB() == -1) updownflag = 1;
            else
            {
                error(); abort();
            }
            rspList.ToPrev();   // ä
            rlflag--;           // rlflag ᤷ
            goto NEXTRSP;       // βƻή˿ʤ
        }

        mGB = rsp->MGB();
        nGB = rsp->NGB();
        umGB = rsp->UpMGB();
        unGB = rsp->UpNGB();
        dmGB = rsp->DownMGB();
        dnGB = rsp->DownNGB();
        gp = rsp->Gpoint();

        udflag = NO;

        if (umGB == dmGB && unGB == dnGB)
        {
            udflag = YES;
            error();
        }

        // ߤǤⱦߤǤƻʬǸʳ, ꥹȤ
        // ϿƤ³
        if ((updownflag == -1 && dmGB != -1) || 
            (updownflag == 1 && umGB != -1))
        {
            assert(rspList.ToNext() == YES); // 
            assert(rspList.ToNext() == YES); // 
            RiversidePoint0* rsptmp = rspList.Get();
            GridPoint3d* gptmp = rsptmp->Gpoint();
            assert(gptmp != NULL);

            gp->ConnectGp(gptmp);
            gptmp->ConnectGp(gp);

            rspList.ToPrev(); // 
            rspList.ToPrev(); // ⤦
        }

        // üФƻήξ
        // üФƻήϡߤ줾ľβƻ
        // ήȤΤ³Τǡ³Ȥλ
        // ƻή˿ʤ

        if ((umGB == -1 && unGB == -1) || (dmGB == -1 && dnGB == -1))
        {
            goto NEXTRSP;
        }

        // ʹߤФ

        int mVal, nVal; // оγʻҺɸ
        int caseVal;    // оΰ֤򼨤ѿ
                        // 1:   8:   7: 
                        // 2:            6: 
                        // 3:   4:   5: 

        // ¦³
        if (rlflag % 2 == 0)    // rlflag ϶
        {
            // caseVal ν
            if (umGB == mGB - 1 && unGB == nGB + 1) // ή¦ˤ
            { mVal = mGB;     nVal = nGB + 1; caseVal = 8; }
            else if (umGB == mGB - 1 && unGB == nGB) // ή¦ˤ
            { mVal = mGB - 1; nVal = nGB + 1; caseVal = 1; }
            else if (umGB == mGB - 1 && unGB == nGB - 1) // ή¦ˤ
            { mVal = mGB - 1; nVal = nGB;     caseVal = 2; }
            else if (umGB == mGB && unGB == nGB - 1) // ή¦ˤ
            { mVal = mGB - 1; nVal = nGB - 1; caseVal = 3; }
            else if (umGB == mGB + 1 && unGB == nGB - 1) // ή¦ˤ
            { mVal = mGB;     nVal = nGB - 1; caseVal = 4; }
            else if (umGB == mGB + 1 && unGB == nGB) // ή¦ˤ
            { mVal = mGB + 1; nVal = nGB - 1; caseVal = 5; }
            else if (umGB == mGB + 1 && unGB == nGB + 1) // ή¦ˤ
            { mVal = mGB + 1; nVal = nGB;     caseVal = 6; }
            else if (umGB == mGB && unGB == nGB + 1) // ή¦̤ˤ
            { mVal = mGB + 1; nVal = nGB + 1; caseVal = 7; }
            else 
            { error(); abort(); }

	    // ή¦α٤ϤƾήޤǷ֤롼
	    for (int i = 1; i <= 8; i++)
	    {
                // оȲή¦פ鼡βƻή³Ȥ˰ܤ
                if (mVal == dmGB && nVal == dnGB)
		{
                    // rspList.ToNext();
                    // rlflag++;
                    // continue;

                    // break;
                    // break ǤԽʬβƻή˰ܤʤФʤʤ
                    // 糰 for 롼פκǸ
                    goto NEXTRSP;
		}

                // (mVal, nVal) ̤ήʤΤ (mGB, nGB) ³Ǥ
                // ǽ
                if (grid(mVal, nVal) != NULL && grid(mVal, nVal)->RiverFlag() == 0)
		{
                    // ³ֵ路(ƻڤ褦³)
                    // ɤǧ

                    // (mVal, nVal)(8),(2),(4),(6)ξ̵OK
                    // ʳξϵ路βǽ
                    if (caseVal == 2 || caseVal == 4 || 
                        caseVal == 6 || caseVal == 8)
                    {
                        // (mGB, nGB)  (mVal, nVal) ߤ³
//                         grid(mGB, nGB)->ConnectGp(grid(mVal, nVal));
//                         grid(mVal, nVal)->ConnectGp(grid(mGB, nGB));
                        gp->ConnectGp(grid(mVal, nVal));
                        grid(mVal, nVal)->ConnectGp(gp);
                    }
                    else
                    {
                        // åо
                        int ma, na;
                        int mb, nb;

                        // ή(mVal, nVal)ˤ
                        if (caseVal == 1)
                        {
                            ma = mGB; na = nGB+1; // 
                            mb = mGB-1; nb = nGB; // 
                        }
                        // ή(mval, nval)ˤ
                        else if (caseVal == 3)
                        {
                            ma = mGB-1; na = nGB; // 
                            mb = mGB; nb = nGB-1; // 
                        }
                        // ή(mval, nval)ˤ
                        else if (caseVal == 5)
                        {
                            ma = mGB; na = nGB-1; // 
                            mb = mGB+1; nb = nGB; // 
                        }
                        // ή(mval, nval)ˤ
                        else
                        {
                            ma = mGB+1; na = nGB; // 
                            mb = mGB; nb = nGB+1; // 
                        }

//                         // åоξȤƻǤʤ³
//                         // RiverFlag() ʤФϲƻ
//                         if (!(grid(ma, na)->RiverFlag() < 0 &&
//                               grid(mb, nb)->RiverFlag() < 0))
                        // åоξȤƻǤʤ³
                        // RiverFlag() ʤФϲƻ
                        if (!(grid(ma, na)->RiverFlag() != 0 &&
                              grid(mb, nb)->RiverFlag() != 0))
                        {
//                             grid(mGB, nGB)->ConnectGp(grid(mVal, nVal));
//                             grid(mVal, nVal)->ConnectGp(grid(mGB, nGB));
                            gp->ConnectGp(grid(mVal, nVal));
                            grid(mVal, nVal)->ConnectGp(gp);
                        }
                        // ξȤƻξϵ路Τ rivunit 
                        // ꥹȤȾȹ礷Ƴǧ
                        else
                        {
                            Boolean cross = NO;
                            rivunitl.ToHead(); 
                            for (Boolean q = YES;
                                 q != NO; 
                                 q = rivunitl.ToNext())
                            {
                                // ƻ˥åȤļФ
                                RivUnit* rivunit = rivunitl.Get();

                                // ξüγʻҺɸФ
                                RiverPoint p1 = rivunit->p1Ref();
                                RiverPoint p2 = rivunit->p2Ref();
                                int m1 = p1.MGB(); int n1 = p1.NGB();
                                int m2 = p2.MGB(); int n2 = p2.NGB();

                                // (ma, na)(mb, nb)ǹƻ˥åȤ
                                //  cross  YES ˤ break 
                                if (((m1 == ma) && (n1 == na) && 
                                     (m2 == mb) && (n2 == nb)) ||
                                    ((m1 == mb) && (n1 == nb) && 
                                     (m2 == ma) && (n2 == na)))
                                {
                                    cross = YES;
                                    break;
                                }
                            }

                            // 򺹤ƻ˥åȤʤäΤ
                            // (mGB, nGB)(mVal, nVal)³
                            if (cross == NO)
                            {
//                                 grid(mGB, nGB)->ConnectGp(grid(mVal, nVal));
//                                 grid(mVal, nVal)->ConnectGp(grid(mGB, nGB));
                                gp->ConnectGp(grid(mVal, nVal));
                                grid(mVal, nVal)->ConnectGp(gp);
                            }
                        }
                    }
		}

                // о򹹿
                if (caseVal == 1) // оˤ뢪̤˰ư
		{ mVal = mGB;     nVal = nGB + 1; caseVal = 8; }
                else if (caseVal == 2) // оˤ뢪˰ư
		{ mVal = mGB - 1; nVal = nGB + 1; caseVal = 1; }
                else if (caseVal == 3) // оˤ뢪˰ư
		{ mVal = mGB - 1; nVal = nGB;     caseVal = 2; }
                else if (caseVal == 4) // оˤ뢪˰ư
		{ mVal = mGB - 1; nVal = nGB - 1; caseVal = 3; }
                else if (caseVal == 5) // оˤ뢪˰ư
		{ mVal = mGB;     nVal = nGB - 1; caseVal = 4; }
                else if (caseVal == 6) // оˤ뢪˰ư
		{ mVal = mGB + 1; nVal = nGB - 1; caseVal = 5; }
                else if (caseVal == 7) // оˤ뢪˰ư
		{ mVal = mGB + 1; nVal = nGB;     caseVal = 6; }
                else if (caseVal == 8) // о̤ˤ뢪˰ư
		{ mVal = mGB + 1; nVal = nGB + 1; caseVal = 7; }
                else // ʳϥ顼
		{ error(); abort(); }

	    } // close for loop
        }
        // ¦³
        // ¦ˤĤƤϡή¦Ȳή¦פƤʤȤΤ
	// ³ȤԤʤ
	// ή¦Ȳή¦פƤ(udflag == YES)³Ȥ
	// åפ
        else if (rlflag % 2 == 1 && udflag == NO)
        {
            // caseVal ν
            if (umGB == mGB - 1 && unGB == nGB + 1) // ή¦ˤ
            { mVal = mGB - 1; nVal = nGB;     caseVal = 2; }
            else if (umGB == mGB - 1 && unGB == nGB) // ή¦ˤ
            { mVal = mGB - 1; nVal = nGB - 1; caseVal = 3; }
            else if (umGB == mGB - 1 && unGB == nGB - 1) // ή¦ˤ
            { mVal = mGB; nVal = nGB - 1;     caseVal = 4; }
            else if (umGB == mGB && unGB == nGB - 1) // ή¦ˤ
            { mVal = mGB + 1; nVal = nGB - 1; caseVal = 5; }
            else if (umGB == mGB + 1 && unGB == nGB - 1) // ή¦ˤ
            { mVal = mGB + 1; nVal = nGB;     caseVal = 6; }
            else if (umGB == mGB + 1 && unGB == nGB) // ή¦ˤ
            { mVal = mGB + 1; nVal = nGB + 1; caseVal = 7; }
            else if (umGB == mGB + 1 && unGB == nGB + 1) // ή¦ˤ
            { mVal = mGB; nVal = nGB + 1;     caseVal = 8; }
            else if (umGB == mGB && unGB == nGB + 1) // ή¦̤ˤ
            { mVal = mGB - 1; nVal = nGB + 1; caseVal = 1; }
            else 
            { error(); abort(); }

	    // ή¦κ٤ϤƾήޤǷ֤롼
	    for (int i = 1; i <= 8; i++)
	    {
                // оȲή¦פ鼡βƻή³Ȥ˰ܤ
                if (mVal == dmGB && nVal == dnGB)
		{
                    // break;
                    // break ǤԽʬβƻή˰ܤʤФʤʤ
                    // 糰 for 롼פκǸ
                    goto NEXTRSP;
		}

                // (mVal, nVal) ̤ήʤΤ (mGB, nGB) ³Ǥ
                // ǽ
//                 if (grid(mVal, nVal) != NULL && grid(mVal, nVal)->RiverFlag() <= 0)
                if (grid(mVal, nVal) != NULL && grid(mVal, nVal)->RiverFlag() == 0)
		{
                    // ³ֵ路(ƻڤ褦³)
                    // ɤǧ

                    // (mVal, nVal)(8),(2),(4),(6)ξ̵OK
                    // ʳξϵ路βǽ
                    if (caseVal == 2 || caseVal == 4 || 
                        caseVal == 6 || caseVal == 8)
                    {
//                         grid(mGB, nGB)->ConnectGp(grid(mVal, nVal));
//                         grid(mVal, nVal)->ConnectGp(grid(mGB, nGB));
                        gp->ConnectGp(grid(mVal, nVal));
                        grid(mVal, nVal)->ConnectGp(gp);
                    }
                    else
                    {
                        // åо
                        int ma, na;
                        int mb, nb;

                        // ή(mVal, nVal)ˤ
                        if (caseVal == 1)
                        {
                            ma = mGB; na = nGB+1; // 
                            mb = mGB-1; nb = nGB; // 
                        }
                        // ή(mVal, nVal)ˤ
                        else if (caseVal == 3)
                        {
                            ma = mGB-1; na = nGB; // 
                            mb = mGB; nb = nGB-1; // 
                        }
                        // ή(mVal, nVal)ˤ
                        else if (caseVal == 5)
                        {
                            ma = mGB; na = nGB-1; // 
                            mb = mGB+1; nb = nGB; // 

//                             // for debugging
//                             cout << "there" << endl;
//                             cout << grid(mGB, nGB)->x() << " " 
//                                  << grid(mGB, nGB)->y() << endl;
//                             cout << grid(mVal, nVal)->x() << " " 
//                                  << grid(mVal, nVal)->y() << endl;
//                             cout << grid(ma, na)->x() << " " 
//                                  << grid(ma, na)->y() << endl;
//                             cout << grid(mb, nb)->x() << " " 
//                                  << grid(mb, nb)->y() << endl;
//                             cout << grid(ma, na)->RiverFlag() << endl;
//                             cout << grid(mb, nb)->RiverFlag() << endl;
//                             cout << endl;
                        }
                        // ή(mVal, nVal)ˤ
                        else
                        {
                            ma = mGB+1; na = nGB; // 
                            mb = mGB; nb = nGB+1; // 
                        }

//                         // åоξȤƻǤʤ³
//                         // RiverFlag() ʤФϲƻ
//                         if (!(grid(ma, na)->RiverFlag() < 0 &&
//                               grid(mb, nb)->RiverFlag() < 0))
                        // åоξȤƻǤʤ³
                        // RiverFlag() ʤФϲƻ
                        if (!(grid(ma, na)->RiverFlag() != 0 &&
                              grid(mb, nb)->RiverFlag() != 0))
                        {
//                             grid(mGB, nGB)->ConnectGp(grid(mVal, nVal));
//                             grid(mVal, nVal)->ConnectGp(grid(mGB, nGB));
                            gp->ConnectGp(grid(mVal, nVal));
                            grid(mVal, nVal)->ConnectGp(gp);
                        }
                        // ξȤƻξϵ路Τ rivunit 
                        // ꥹȤȾȹ礷Ƴǧ
                        else
                        {

//                             // for debugging
//                             cout << "here" << endl;
//                             cout << grid(mGB, nGB)->x() << " " 
//                                  << grid(mGB, nGB)->y() << endl;
//                             cout << grid(mVal, nVal)->x() << " " 
//                                  << grid(mVal, nVal)->y() << endl;
//                             cout << grid(ma, na)->x() << " " 
//                                  << grid(ma, na)->y() << endl;
//                             cout << grid(mb, nb)->x() << " " 
//                                  << grid(mb, nb)->y() << endl;
//                             cout << endl;

                            Boolean cross = NO;
                            rivunitl.ToHead(); 
                            for (Boolean q = YES;
                                 q != NO; 
                                 q = rivunitl.ToNext())
                            {
                                // ƻ˥åȤļФ
                                RivUnit* rivunit = rivunitl.Get();

                                // ξüγʻҺɸФ
                                RiverPoint p1 = rivunit->p1Ref();
                                RiverPoint p2 = rivunit->p2Ref();
                                int m1 = p1.MGB(); int n1 = p1.NGB();
                                int m2 = p2.MGB(); int n2 = p2.NGB();

                                // (ma, na)(mb, nb)ǹƻ˥åȤ
                                //  cross  YES ˤ break 
                                if (((m1 == ma) && (n1 == na) && 
                                     (m2 == mb) && (n2 == nb)) ||
                                    ((m1 == mb) && (n1 == nb) && 
                                     (m2 == ma) && (n2 == na)))
                                {
                                    cross = YES;
                                    break;
                                }
                            }

                            // 򺹤ƻ˥åȤʤäΤ
                            // (mGB, nGB)(mVal, nVal)³
                            if (cross == NO)
                            {
//                                 grid(mGB, nGB)->ConnectGp(grid(mVal, nVal));
//                                 grid(mVal, nVal)->ConnectGp(grid(mGB, nGB));
                                gp->ConnectGp(grid(mVal, nVal));
                                grid(mVal, nVal)->ConnectGp(gp);
                            }
                        }
                    }
		}

                // о򹹿()
                if (caseVal == 1) // оˤ뢪˰ư
		{ mVal = mGB - 1; nVal = nGB;     caseVal = 2; }
                else if (caseVal == 2) // оˤ뢪˰ư
		{ mVal = mGB - 1; nVal = nGB - 1; caseVal = 3; }
                else if (caseVal == 3) // оˤ뢪˰ư
		{ mVal = mGB; nVal = nGB - 1;     caseVal = 4; }
                else if (caseVal == 4) // оˤ뢪˰ư
		{ mVal = mGB + 1; nVal = nGB - 1; caseVal = 5; }
                else if (caseVal == 5) // оˤ뢪˰ư
                    //		{ mVal = mGB;     nVal = nGB - 1; caseVal = 6; }
                { mVal = mGB + 1; nVal = nGB; caseVal = 6; }
                else if (caseVal == 6) // оˤ뢪˰ư
		{ mVal = mGB + 1; nVal = nGB + 1; caseVal = 7; }
                else if (caseVal == 7) // оˤ뢪̤˰ư
		{ mVal = mGB; nVal = nGB + 1;     caseVal = 8; }
                else if (caseVal == 8) // о̤ˤ뢪˰ư
		{ mVal = mGB - 1; nVal = nGB + 1; caseVal = 1; }
                else // ʳϥ顼
		{ error(); abort(); }

	    } // close for loop
	} // close else if

        // βƻήؿʤ
        NEXTRSP:;

    } // close for rspList

    return;
}

// ********************************************************************
void
RiversideWork(		// ƻ֤ȿ׼ˤޤʤ顢ƻή
			// ƻήꥹȤϿ
              Grid<GridPoint3d*>& grid, // åɤĺ
              SListDynamic<RiverPoint*>& chaseList,	// ƻȿ׼Ͽ
              // ꥹ
              DList<RiversidePoint0*>& rspList	// ƻήꥹ
              )
{
    // ƻ֤ȿ׼ˤޤʤ顢ƻήϿ
    // ꥹȤϿξϡƻ̵֤Ȥ return 
    if (chaseList.GetCount() == 0) { return; }

    int m0 = -1; int n0 = -1;
    int m1 = -1; int n1 = -1;
    int m2 = -1; int n2 = -1;
    int m3 = -1; int n3 = -1;

    RiversidePoint0* prevrsp;
    RiversidePoint0* rsp;
    RiversidePoint0* sentinel = new RiversidePoint0;
    assert(sentinel != NULL);
    sentinel->SetUpGCoord(-1, -1);
    sentinel->SetGCoord(-1, -1);
    sentinel->SetDownGCoord(-1, -1);
    sentinel->SetGpNull();

    chaseList.ToHead();
    // оݤ (m2, n2) Ȥ
    Boolean endflag = NO;
    Metric xval, yval; 
    ElvType zval;
    int nval;
    while (1)
    {
        RiverPoint* rp = chaseList.Get();
        m3 = rp->MGB(); n3 = rp->NGB();

        if ((m0 == -1 && n0 == -1) && (m1 == -1 && n1 == -1) &&
            (m2 == -1 && n2 == -1))
        { /* ⤷ʤ */ }
        else if ((m0 == -1 && n0 == -1) && (m1 == -1 && n1 == -1))
        {
            // (m2, n2) ü
            if (m2 == m3 && n2 == n3)
            { error(); abort(); }
	  
            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval * (-1));
            rsp->SetGCoord(m2, n2); 
            rsp->SetUpGCoord(m3, n3);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval * (-1));
        }
        else if ((m0 == -1 && n0 == -1) && (m2 == m3 && n2 == n3)) 
        {
            // (m2, n2) ü⤷Ϲή
            if (m1 == m3 && n1 == n3)
            { error(); abort(); }

            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval * (-1));
            rsp->SetGCoord(m2, n2); rsp->SetDownGCoord(m1, n1);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval * (-1));
            prevrsp = rsp;
        }
        else if (m0 == -1 && n0 == -1)
        {
            // (m2, n2) 
            if (m2 == m3 && n2 == n3)
            { error(); abort(); }
            else if (m1 == m2 && n1 == n2)
            { error(); abort(); }

            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval);
            rsp->SetGCoord(m2, n2);
            rsp->SetUpGCoord(m3, n3); rsp->SetDownGCoord(m1, n1);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval);
        }
        else if ((m3 == -1 && n3 == -1) && (m0 == m1 && n0 == n1))
        { /* ƻ֤νλ */ 
            // (m2, n2) ü
            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval * (-1));
            rsp->SetGCoord(m2, n2);
            rsp->SetDownGCoord(m1, n1);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval * (-1));
            endflag = YES;
        }
        else if (m3 == -1 && n3 == -1)
        { /* ƻ֤νλ */ 
            // (m2, n2) ü
            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval * (-1));
            rsp->SetGCoord(m2, n2);
            rsp->SetDownGCoord(m1, n1);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval * (-1));
            endflag = YES;
        }
        else if ((m0 == m1 && n0 == n1) && (m2 == m3 && n2 == n3))
        {
            // (m2, n2) Ϲή⤷ü
            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval * (-1));
            rsp->SetGCoord(m2, n2);
            rsp->SetDownGCoord(m1, n1);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval * (-1));
            prevrsp = rsp;
        }
        else if (m0 == m1 && n0 == n1)
        {
            // (m2, n2) 
            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval);
            rsp->SetGCoord(m2, n2);
            rsp->SetDownGCoord(m1, n1); rsp->SetUpGCoord(m3, n3);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval);
        }
        else if ((m1 == m2 && n1 == n2) && (m0 == m3 && n0 == n3))
        {
            // (m2, n2) ü
            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval * (-1));
            rsp->SetGCoord(m2, n2);
            rsp->SetUpGCoord(m3, n3);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval * (-1));
        }
        else if (m1 == m2 && n1 == n2)
        {
            // (m2, n2) Ϲή
            prevrsp->SetUpGCoord(m3, n3);
            (prevrsp->Gpoint())->RiverFlag(nval);
            grid(m2, n2)->RiverFlag(nval);
        }
        else if (m2 == m3 && n2 == n3)
        {
            // (m2, n2) ü⤷Ϲή
            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval * (-1));
            rsp->SetGCoord(m2, n2);
            rsp->SetDownGCoord(m1, n1);
            rspList.Append(rsp);
            grid(m2, n2)->RiverFlag(nval * (-1));
            prevrsp = rsp;
        }
        else
        { /* m0  m3n0  n3 ưۤʤʻҺɸ */ 
            // (m2, n2) 
            rsp = new RiversidePoint0;
            assert(rsp != NULL);
            (rsp->Gpoint())->SetVal(xval, yval, zval);
            (rsp->Gpoint())->RiverFlag(nval);
            rsp->SetGCoord(m2, n2);
            rsp->SetDownGCoord(m1, n1); rsp->SetUpGCoord(m3, n3);
            grid(m2, n2)->RiverFlag(nval);
            rspList.Append(rsp);
        }

        if (endflag == YES)
        {
            m0 = -1; n0 = -1; m1 = -1; n1 = -1; m2 = -1; n2 = -1;
            xval = -1; yval = -1; zval = -1;
            rspList.Append(sentinel);
            endflag = NO;
        }
        else
        {
            m0 = m1; n0 = n1; m1 = m2; n1 = n2; m2 = m3; n2 = n3;
            xval = rp->x(); yval = rp->y(); zval = grid(m3, n3)->z();
            nval = rp->Number();
        }
        if (chaseList.ToNext() == NO) break;
    }
    return;
}

// // ********************************************************************
// void
// RiverChase0(		// ƻ֤ȿײˤޤʤƻꥹ
// 			// ȤϿƤ
//             DList<NodeL*>& nodepList, // ꥹ
//             SListDynamic<RiverPoint*>& chaseList // ȿײ˲ƻϿ
//             // 
//             )
// {
//     // Ͽ줿ꥹȤϿξϡƻ̵֤Ȥ
//     // Ȥ return 
//     // Ͽ줿ꥹȤϿξϥ顼
//     if (nodepList.GetCount() == 0) { return; }
//     else if (nodepList.GetCount() == 1)	{ error(); abort(); }
  
//     RiverPoint* sentinel = new RiverPoint;
//     sentinel->SetVal(-1, -1, -1, -1, -1, -1, -1);

//     // ƤΥΡɤ ToHead() 
//     nodepList.ToHead();
//     while (1)
//     {
//         NodeL* tmpnode = nodepList.Get();
//         if (tmpnode->GetCount() < 1) { error(); abort(); }
//         tmpnode->ToHead();
      
//         if (nodepList.AtTail() == YES) break;
//         if (nodepList.ToNext() == NO) break;
//     }
  
//     Boolean endFlag = NO;
//     while (endFlag == NO)
//     {
//         // ƻ֤κǾή⤷ϺǲήߤĤ
//         // 
//         NodeL* nodep;
//         nodepList.ToHead();
//         int nlisttotal = nodepList.GetCount();
//         int nlistcount = 0; 
//         Boolean oneFlag = YES; // YES: ƻ֤Ĥβƻʬǹ
//         // NO : ƻ֤İʾβƻʬǹ
//         while (1)
//         {
//             nodep = nodepList.Get();
//             if (nodep->GetCount() == 1) 
//             {
//                 if ((nodep->Get())->ChaseFlag() == -1)
//                 { break; }
//             }
//             if (nodepList.ToNext() == NO) 
//             { endFlag = YES; break; }
//             nlistcount++;
//             if (nlistcount > nlisttotal) 
//             { endFlag = YES; break; }
//         }
      
//         if (endFlag == NO)
//         {
//             //yi Ρ nodep ϿƤƻʬļФ
//             Rseg* rsegp = nodep->Get(); // nodep ϴ ToHead() Ƥ
//             rsegp->ChaseFlag(1);
	  
//             Rseg* startrsegp = rsegp;
	  
//             Boolean flag = NO; // YES: ׽λNO: ̤λ
//             NodeL* prenodep;
//             Rseg* nextrsegp;
//             RiverPoint* rpp;
	  
//             while (flag == NO)
//             {
//                 //yi ƻʬ rsegp äƤƻΥꥹȤФ
//                 DList<RiverPoint*>& rppList = rsegp->StrmpList();
	      
//                 int seFlag = 0; // 1: start  end-1: end  start
//                 if (nodep == rsegp->StartNodeLp())
//                 {
//                     seFlag = 1;
//                     rppList.ToHead();
//                     while (1)
//                     {
//                         /*  */
//                         rpp = rppList.Get(); 
//                         chaseList.Append(rpp);
		      
//                         if (rppList.ToNext() == NO) 
//                         {
//                             prenodep = nodep;
//                             nodep = rsegp->EndNodeLp();
//                             break;
//                         }
//                     }
//                 }
//                 else
//                 {
//                     seFlag = -1;
//                     rppList.ToTail();
//                     while (1)
//                     {
//                         /*  */
//                         rpp = rppList.Get(); 
//                         chaseList.Append(rpp);
		      
//                         if (rppList.ToPrev() == NO) 
//                         {
//                             prenodep = nodep;
//                             nodep = rsegp->StartNodeLp();
//                             break;
//                         }
//                     }
//                 }

//                 //yi ƻ֤ҤȤᤰꤷƤΤ׽λ
//                 if (nodep->GetCount() == 1 && oneFlag == NO &&
//                     rsegp == startrsegp)
//                 { 
//                     flag = YES; /* ׽λ */ 
//                     chaseList.Append(sentinel);
//                 }
//                 //yi ƻ֤üޤ褿ΤäƤ
//                 else if (nodep->GetCount() == 1) 
//                 { 
//                     /* βƻ֤õ */ 
//                     if (seFlag == 1)
//                     {
//                         seFlag = -1;
//                         rppList.ToTail();
//                         while (1)
//                         {
//                             /*  */
//                             rpp = rppList.Get(); 
//                             chaseList.Append(rpp);
			  
//                             if (rppList.ToPrev() == NO) 
//                             {
//                                 prenodep = nodep;
//                                 nodep = rsegp->StartNodeLp();
//                                 break;
//                             }
//                         }
//                     }
//                     else if (seFlag == -1)
//                     {
//                         seFlag = 1;
//                         rppList.ToHead();
//                         while (1)
//                         {
//                             /*  */
//                             rpp = rppList.Get(); 
//                             chaseList.Append(rpp);
			  
//                             if (rppList.ToNext() == NO) 
//                             {
//                                 prenodep = nodep;
//                                 nodep = rsegp->EndNodeLp();
//                                 break;
//                             }
//                         }
//                     }
//                     else
//                     { error(); abort(); }
		  
//                     if (nodep->GetCount() == 1) 
//                     { 
//                         flag = YES; /* ׽λ */ 
//                         chaseList.Append(sentinel);
//                     }
//                     else if (nodep->GetCount() > 1)
//                     {
//                         while (1)
//                         {
//                             nextrsegp = nodep->Get();
//                             if (nextrsegp == rsegp)
//                             {
//                                 if (nodep->ToNext() == NO) 
//                                 { 
//                                     // error(); abort(); 
//                                     nodep->ToHead();
//                                 }
//                                 rsegp = nodep->Get();
//                                 oneFlag = NO;
//                                 break;
//                             }
//                             if (nodep->ToNext() == NO) 
//                             { 
//                                 // error(); abort(); 
//                                 nodep->ToHead();
//                             }
//                         }
//                         rsegp->ChaseFlag(1);
//                     }
//                     else
//                     { error(); abort(); }
//                 }
//                 else if (nodep->GetCount() > 1)
//                 {
//                     while (1)
//                     {
//                         nextrsegp = nodep->Get();
//                         if (nextrsegp == rsegp)
//                         {
//                             if (nodep->ToNext() == NO) 
//                             { 
//                                 // error(); abort();
//                                 nodep->ToHead();
//                             }
//                             rsegp = nodep->Get();
//                             oneFlag = NO;
//                             break;
//                         }
//                         if (nodep->ToNext() == NO) 
//                         { 
//                             // error(); abort();
//                             nodep->ToHead();
//                         }
//                     }
//                     rsegp->ChaseFlag(1);
//                 }
//                 else
//                 { error(); abort(); }
//             }
//         }
//     }
//     return;
// }

// ********************************************************************
// mod. by iYutaka (Sat Nov  2 16:49:55 2002)

// ƻ֤򤿤ɤʤ顢ƻήƤޤƻȲ
// ƻ֥˥åȤꥹȤϿƤ

void
RiverChase
( 
 // DList<NodeL*>& nodepList, // ꥹ
 // SListDynamic<RiverPoint*>& chaseList // ȿײ˲ƻϿꥹ
 Grid<GridPoint3d*>& grid,             // åɤĺ
 DList<Rseg*>& rsegl,                  // ƻʬΥꥹ
 DList<RiversidePoint0*>& rspl, // ƻήΥꥹ
 DList<RivUnit*>& rivunitl       // ƻȲƻĤʤ˥åȤΥꥹ
)
{
    // ƻʬο 0 ξϲƻ̵֤ʤΤǡ
    // Ȥ return 
    if (rsegl.GetCount() == 0) { return; }

    rsegl.ToHead();
    for (Boolean r = YES; r != NO; r = rsegl.ToNext())
    {
        // ꥹȤƻʬļФ
        Rseg* rsegp = rsegl.Get();

        // βƻʬβƻΥꥹȤФ
        DList<RiverPoint*>& rpl = rsegp->StrmpList();

        // ƻʬФ(üޤ)줾ƻή֤

        RiversidePoint0* rspLeft;
        RiversidePoint0* rspRight;
        //        int numrp = rpl.GetCount(); // ƻθĿ

        RiverPoint* rpprev = NULL;
        RiverPoint* rp;
        RiverPoint* rpnext;
        int mprev = -1; int nprev = -1;
        int m, n;
        int mnext, nnext;

        // ƻʬλϤޤ̣ sentinel  rspl  Append Ƥ
        RiversidePoint0* sentinel = new RiversidePoint0;
        assert(sentinel != NULL);
        sentinel->SetUpGCoord(-1, -1);
        sentinel->SetGCoord(-1, -1);
        sentinel->SetDownGCoord(-1, -1);
        sentinel->SetGpNull();
        rspl.Append(sentinel);

        RivUnit* rivunit;

        // rpl ƬϿƤȤ򳫻
        rpl.ToHead();
        for (Boolean q = YES; q != NO; q = rpl.ToNext())
        {
            // ƻļФ
            rp = rpl.Get();

            // ʻҺɸĴ٤
            m = rp->MGB();
            n = rp->NGB();

            // ȺƱʤٹФƽ򥹥åפ
            if (m == mprev && n == nprev)
            {
                warning();
                cerr << "The two points are located at the same point." << endl;
                cerr << "[" << m << ":" << n << "]" << endl;
                //                abort();
                continue;
            }

            // x, y, z ɸĴ٤
//             Metric x = rp->x();
//             Metric y = rp->y();
//             ElvType z = rp->z();

            Metric x = grid(m, n)->x();
            Metric y = grid(m, n)->y();
            ElvType z = grid(m, n)->z();
            int nval = rp->Number();

            // ƻή
            rspLeft = new RiversidePoint0;
            assert(rspLeft != NULL);
            rspRight = new RiversidePoint0;
            assert(rspRight != NULL);

            // x, y, z ɸͿ
            (rspLeft->Gpoint())->SetVal(x, y, z);
            (rspRight->Gpoint())->SetVal(x, y, z);

            // оüʤ rivflag ͤˤ
            if (rpl.AtHead() == YES || rpl.AtTail() == YES)
            {
                grid(m, n)->RiverFlag(nval*(-1));
                (rspLeft->Gpoint())->RiverFlag(nval*(-1));
                (rspRight->Gpoint())->RiverFlag(nval*(-1));
            }
            // оʤ rivflag ͤˤ
            else
            {
                grid(m, n)->RiverFlag(nval);
                (rspLeft->Gpoint())->RiverFlag(nval);
                (rspRight->Gpoint())->RiverFlag(nval);
            }

            // ʻҺɸͿ
            rspLeft->SetGCoord(m, n); 
            rspRight->SetGCoord(m, n); 

            // 岼ήƻή

            // rpl κǸǤʤ
            if (rpl.AtTail() == NO)
            {
                rpl.ToNext(); // Ŀʤơ
                rpnext = rpl.Get();
                mnext = rpnext->MGB();
                nnext = rpnext->NGB();
                rpl.ToPrev(); // 
            }
            // Ǹξ
            else
            {
                rpnext = NULL;
                mnext = -1;
                nnext = -1;
            }

            // ȺƱʤ饨顼
            if (m == mnext && n == nnext)
            {
                error();
                abort();
            }

            // ȼƱʤ饨顼
            // Υ顼 remakeRiverData ʤбǤʤ
            if (mprev == mnext && nprev == nnext)
            {
                error();
                cout << rpprev->x() << " " << rpprev->y() << endl;
                //                abort();
            }

            // ƻή鲼ήν˥ꥹȤϿƤ
            if (rsegp->UpdownFlag() == -1)
            {
                rspLeft->SetUpGCoord(mprev, nprev);
                rspRight->SetUpGCoord(mprev, nprev);
                rspLeft->SetDownGCoord(mnext, nnext);
                rspRight->SetDownGCoord(mnext, nnext);
            }
            // ƻήήν˥ꥹȤϿƤ
            else if (rsegp->UpdownFlag() == 1)
            {
                rspLeft->SetDownGCoord(mprev, nprev);
                rspRight->SetDownGCoord(mprev, nprev);
                rspLeft->SetUpGCoord(mnext, nnext);
                rspRight->SetUpGCoord(mnext, nnext);
            }
            // ꤨʤ
            else
            {
                error(); abort();
            }

            // ƻήꥹȤϿ
            rspl.Append(rspLeft);
            rspl.Append(rspRight);

            // mprev, nprev ι
            mprev = m; nprev = n;

            // ƻȲƻ֥˥åȤꥹȤ˼Ͽ
            if (rpprev != NULL)
            {
                rivunit = new RivUnit(*rpprev, *rp);
                rivunitl.Append(rivunit);
            }

            // rpprev ι
            rpprev = rp;
        }

//         // ƻʬκǸФ
//         // for 롼פȴǺǸƤϤ
//         rp = rpl.Get();
//         rivunit = new RivUnit(*rpprev, *rp);
//         rivunitl.Append(rivunit);

//         // ƻʬǸФƤ RiverFlag(nval*(-1)) ¹Ԥ
//         m = rp->MGB();
//         n = rp->NGB();
//         nval = rp->Number();
//         grid(m, n)->RiverFlag(nval*(-1));

        // ʾǤƻʬβƻФλ
    }

    return;
}

// ********************************************************************
void
RspListPrint(		// ƻήΥꥹȤ(ƻή)ν
			// 
             DList<RiversidePoint0*>& rspList // ƻήꥹ
             )
{
    if (rspList.GetCount() == 0)
    {
        cout << "No riversidepoints exists." << endl;
        return;
    }

    int ct = 1;
    rspList.ToHead();
    while (1)
    {
        RiversidePoint0* rsp = rspList.Get();
        cout << ct++ << "   "
             << rsp->UpMGB() << " " << rsp->UpNGB() << "   "
             << rsp->MGB() << " " << rsp->NGB() << "   "
             << rsp->DownMGB() << " " << rsp->DownNGB() << "   ";

        GridPoint3d* gp = rsp->Gpoint(); 
        if (gp != NULL)
	{
            cout << "(" << gp->x() << ", "
                 << gp->y() << ", "
                 << gp->z() << ")" << endl;
            DList<GridPoint3d*>& gpList = gp->NeighborGp();
            if (gpList.GetCount() > 0)
	    {
                gpList.ToHead();
                while (1)
		{
                    GridPoint3d* tmpgp = gpList.Get();
                    cout << " "
                         << "(" << tmpgp->x() << ","
                         << tmpgp->y() << ","
                         << tmpgp->z() << ")";
                    if (gpList.ToNext() == NO) break;
		}
	    }
	}
        else
            cout << "(NULL)";
	      
        cout << endl;

        if (rspList.ToNext() == NO) break;
    }

    return;
}

// ********************************************************************
void
GnuDataPrint(		// gnuplot ѥǡν
             char* fname,		// gnuplot ѥǡե̾
             Grid<GridPoint3d*>& grid, // ή
             DList<RiversidePoint0*>& rspList // ƻήꥹ
             )
{
    ofstream output(fname);
    if(!output) {
        cerr << "Cannot open " << fname << endl;
        exit(1);
    }

    int rowval = grid.GetRows();
    int colval = grid.GetCols();
     Metric x, y; 
     ElvType  z;
     for (int ir = 0; ir < rowval; ir++)
     {
         for (int ic = 0; ic < colval; ic++)
 	{
             GridPoint3d* gp = grid(ir, ic);
             if (gp != NULL)
             {
                 // ܤήȲ³ƤήϤ
                 DList<GridPoint3d*>& ngpList = gp->NeighborGp();
                 if (ngpList.GetCount() > 0)
 		{
                     ngpList.ToHead();
                     while (1)
 		    {
                         GridPoint3d* ngp = ngpList.Get();
                         if (gp->x() > XMIN && gp->x() < XMAX &&
                             gp->y() > YMIN && gp->y() < YMAX)
 			{
                             x = gp->x(); y = gp->y(); z = gp->z();
                             output << gp->x() << " " << gp->y() << " "
                                    << gp->z() << "\n";
                             output << ngp->x() << " "
                                    << ngp->y() << " "
                                    << ngp->z() << "\n\n";
 			}
                         if (ngpList.ToNext() == NO) break;
 		    }
 		}
 	    }
 	}
     }

    if (rspList.GetCount() == 0)
    {
        output << x << " " << y << " " << z << "\n";
        return;
    }
    else
    {
        rspList.ToHead();
        while (1)
	{
            RiversidePoint0* rsp = rspList.Get();
            GridPoint3d* gp = rsp->Gpoint();
            if (gp != NULL)
	    {
                DList<GridPoint3d*>& ngpList = gp->NeighborGp();
                if (ngpList.GetCount() > 0)
		{
                    ngpList.ToHead();
                    while (1)
		    {
                        GridPoint3d* ngp = ngpList.Get();
                        if (gp->x() > XMIN && gp->x() < XMAX &&
                            gp->y() > YMIN && gp->y() < YMAX)
			{
                            x = gp->x(); y = gp->y(); z = gp->z();
                            output << gp->x() << " " << gp->y() << " "
                                   << gp->z() << "\n";
                            output << ngp->x() << " "
                                   << ngp->y() << " "
                                   << ngp->z() << "\n\n";
			}
                        if (ngpList.ToNext() == NO) break;
		    }
		}
	    }

            if (rspList.ToNext() == NO) 
	    {
                output << x << " " << y << " " << z << "\n";
                break;
	    }
	}
    }

    output.close();
    return;
}

// ********************************************************************
void
OutputNewriver(			// ƹƻֹ֤դƥե
				// ˽Ϥ 
               char* fname,			// ϥե̾
               DList<NodeL*>& nodeList,	// ꥹ
               DList<Rseg*>& newrsegList	// ƹβƻʬꥹ
               )
{
    if (nodeList.GetCount() == 0 ||  newrsegList.GetCount() == 0) 
        return;
  
    // Ρɤ˿ֹĤ
    int num = 1;
    if (nodeList.GetCount() == 0) { error(); abort(); }
  
    nodeList.ToHead();
    while (1)
    {
        NodeL* tmpnode = nodeList.Get();
        tmpnode->Number(num);
        num++;
      
        if (nodeList.ToNext() == NO) break;
    }
  
    // Ϥե
    ofstream output(fname);
    if (!output)
    {
        cerr << "Cannot open " << fname << endl;
        error(); abort();
    }
    output << "# ֹ  xɸ yɸ ɸ\n";
  
    if (newrsegList.GetCount() == 0) { error(); abort(); }
    newrsegList.ToHead();
    while (1)
    {
        Rseg* tmprseg = newrsegList.Get();
        DList<RiverPoint*>& strmList = tmprseg->StrmpList();
      
        if (strmList.GetCount() == 0)
	{
            error(); abort();
	}
      
        int updownChk = tmprseg->UpdownFlag();
      
        strmList.ToHead();
        while (1)
	{
            RiverPoint* tmprp = strmList.Get();
            // mod. by iYutaka (Fri Nov  1 21:32:58 2002)
            output << setw(8) << tmprp->Number() << " " ; // ƻֹ
            if (strmList.AtHead() == YES)	// Ϥ
	    {
                if (updownChk == 1)
                    output << setw(4) 
                           << ((tmprseg->StartNodeLp())->Number()) * (-1)
                           << " ";
                else
                    output << setw(4) 
                           << ((tmprseg->StartNodeLp())->Number()) << " ";
	    }
            else if (strmList.AtTail() == YES) // 
	    {
                if (updownChk == 1)
                    output << setw(4) 
                           << ((tmprseg->EndNodeLp())->Number()) << " ";
                else
                    output << setw(4)
                           << ((tmprseg->EndNodeLp())->Number()) * (-1) 
                           << " ";
	    }
            else			// 
                output << setw(4) << 0;
	  
            output << setw(8) << tmprp->x() << " " 
                   << setw(8) << tmprp->y() << " "
                   << setw(8) << tmprp->z() << "\n";
	  
            if (strmList.ToNext() == NO) break;
	}
      
        if (newrsegList.ToNext() == NO) break;
    }
    output.close();
    return;
}

// // ********************************************************************
// void
// OutputTmpCntData(	// ³ήξե˽Ϥ
//                  Grid<GridPoint3d*>& grid,         // ʻҤϿ줿ή
//                  DList<RiversidePoint0*>& rspList, // ƻήΥꥹ
//                  char* fname1			    // Ϥήե̾
//                  )
// {
//     // ήβ³ϡֹ򻲾Ȥ뤳Ȥˤǧ뤳Ȥ
//     // Τǡήֹꤹ

//     int number = 1;
//     int rowval = grid.GetRows();
//     int colval = grid.GetCols();
//     SListDynamic<GridPoint3d*> endgpList;
//     for (int ir = 0; ir < rowval; ir++)
//     {
//         for (int ic = 0; ic < colval; ic++)
// 	{
//             GridPoint3d* gp = grid(ir, ic);
//             if (gp != NULL && gp->RiverFlag() == 0)
// 	    {
//                 gp->Number(number++);
// 	    }
//             else if (gp != NULL && gp->RiverFlag() < 0)
//                 endgpList.Append(gp);
// 	}
//     }

//     if (endgpList.GetCount() > 0)
//     {
//         endgpList.ToHead();
//         while (1)
// 	{
//             (endgpList.Get())->Number(number++);
//             if (endgpList.ToNext() == NO) break;
// 	}
//     }

//     // ƻήϿ줿ꥹȤϿξϡƻ̵֤
//     // ȤơȤʤ
//     // ƻήϿ줿ꥹȤϿ̤ξϥ顼
//     if (rspList.GetCount() == 0) { }
//     else if (rspList.GetCount() < 4) { error(); abort(); }
//     else
//     {
//         rspList.ToHead();
//         while (1)
// 	{
//             RiversidePoint0* rsp = rspList.Get();
//             GridPoint3d* gp = rsp->Gpoint();
//             if (gp != NULL)
// 	    {
//                 gp->Number(number++);
// 	    }
//             if (rspList.ToNext() == NO) break;
// 	}
//     }

//     // ήβ³ե˽Ϥ
//     ofstream output1(fname1);
//     if (!output1)
//     {
//         cerr << "Cannot open " << fname1 << endl;
//         error(); abort();
//     }
// //      output1 << "# ֹ xɸ(m) yɸ(m) zɸ(m) (m2) "
// //              << "ƻήȽ ³ ³Ƥֹ\n"
// //              << "# () ƻήȽ  1:ƻή  "
// //              << "0:ƻήǤϤʤ\n"
// //              << "# () ֺǽο\n";
//     output1 << "# This data was generated by temporaryConnect " << Version() << endl;
//     output1 << "# ֹ xɸ(m) yɸ(m) zɸ(m) (m2) "
//             << "μ ³ ³Ƥֹ\n"
//             << "# (1) μ  -1:ɸͤͿƤΰü˰֤  "
//             << "0:ή  ο:ƻ⤷ϲƻή\n"
//             << "# (2) ֺǽο\n";

//     output1 << number - 1 << "\n";
//     //  for (ir = 0; ir < rowval; ir++)
//     for (int ir = 0; ir < rowval; ir++)
//     {
//         for (int ic = 0; ic < colval; ic++)
// 	{
//             GridPoint3d* gp = grid(ir, ic);
//             if (gp != NULL && gp->RiverFlag() == 0)
// 	    {
//                 output1 << setw(8) << gp->Number() << " "
//                         << setw(8) << gp->x() << " "
//                         << setw(8) << gp->y() << " "
//                         << setw(15) << gp->z() << " "
//                         << setw(15) << gp->Area() << " ";
//                 if (gp->EdgeFlag() == 1)
//                     output1 << setw(6) << -1 << " ";
//                 else
//                     output1 << setw(6) << 0 << " ";
	      
//                 output1 << setw(3) << gp->CntNum();
//                 DList<GridPoint3d*>& ngpList = gp->NeighborGp();
//                 if (ngpList.GetCount() > 0)
// 		{
//                     ngpList.ToHead();
//                     while (1)
// 		    {
//                         GridPoint3d* ngp = ngpList.Get();
//                         output1 << setw(8) << ngp->Number() << " ";
//                         if (ngpList.ToNext() == NO) break;
// 		    }
// 		}
//                 output1 << "\n";
// 	    }
// 	}
//     }

//     if (endgpList.GetCount() > 0)
//     {
//         endgpList.ToHead();
//         while (1)
// 	{
//             GridPoint3d* gp = endgpList.Get();

//             output1 << setw(8) << gp->Number() << " "
//                     << setw(8) << gp->x() << " "
//                     << setw(8) << gp->y() << " "
//                     << setw(15) << gp->z() << " "
//                     << setw(15) << gp->Area() << " ";
//             if (gp->RiverFlag() < 0)
//                 output1 << setw(6) << (gp->RiverFlag()) * (-1) << " ";
//             else
//                 output1 << setw(6) << gp->RiverFlag() << " ";

//             output1 << setw(3) << gp->CntNum() << " ";
//             DList<GridPoint3d*>& ngpList = gp->NeighborGp();
//             if (ngpList.GetCount() > 0)
// 	    {
//                 ngpList.ToHead();
//                 while (1)
// 		{
//                     GridPoint3d* ngp = ngpList.Get();
//                     output1 << setw(8) << ngp->Number() << " ";
//                     if (ngpList.ToNext() == NO) break;
// 		}
// 	    }

//             output1 << "\n";

//             if (endgpList.ToNext() == NO) break;
// 	}
//     }


//     // ƻήϿ줿ꥹȤϿξϡƻ̵֤
//     // Ȥơե close  return 
//     if (rspList.GetCount() == 0) 
//     { output1.close();  return; }
//     rspList.ToHead();
//     while (1)
//     {
//         RiversidePoint0* rsp = rspList.Get();
//         GridPoint3d* gp = rsp->Gpoint();
//         if (gp != NULL)
// 	{
//             output1 << setw(8) << gp->Number() << " "
//                     << setw(8) << gp->x() << " "
//                     << setw(8) << gp->y() << " "
//                     << setw(8) << gp->z() << " "
//                     << setw(8) << gp->Area() << " ";
//             if (gp->RiverFlag() < 0)
//                 output1 << setw(6) << (gp->RiverFlag()) * (-1) << " ";
//             else
//                 output1 << setw(6) << gp->RiverFlag() << " ";

//             output1 << setw(3) << gp->CntNum() << " ";
//             DList<GridPoint3d*>& ngpList = gp->NeighborGp();
//             if (ngpList.GetCount() > 0)
// 	    {
//                 ngpList.ToHead();
//                 while (1)
// 		{
//                     GridPoint3d* ngp = ngpList.Get();
//                     output1 << setw(8) << ngp->Number() << " ";
//                     if (ngpList.ToNext() == NO) break;
// 		}
// 	    }
//             output1 << "\n";
// 	}

//         if (rspList.ToNext() == NO) break;
//     }

//     output1.close();
//     return;
// }

// ********************************************************************
// mod. by iYutaka (Wed Nov 13 21:43:34 2002)
// üȽŤʤ grid ξ񤭽Фʤ褦ˤ
// ƻȽŤʤ grid ξϤȤȽ񤭽ФƤʤ
void
OutputTmpCntData(	// ³ήξե˽Ϥ
                 Grid<GridPoint3d*>& grid,         // ʻҤϿ줿ή
                 DList<RiversidePoint0*>& rspList, // ƻήΥꥹ
                 char* fname1			    // Ϥήե̾
                 )
{
    // ήβ³ϡֹ򻲾Ȥ뤳Ȥˤǧ뤳Ȥ
    // Τǡήֹꤹ

    int number = 1;
    int rowval = grid.GetRows();
    int colval = grid.GetCols();
//    SListDynamic<GridPoint3d*> endgpList;
    for (int ir = 0; ir < rowval; ir++)
    {
        for (int ic = 0; ic < colval; ic++)
	{
            GridPoint3d* gp = grid(ir, ic);
            if (gp != NULL && gp->RiverFlag() == 0)
	    {
                gp->Number(number++);
	    }
//             else if (gp != NULL && gp->RiverFlag() < 0)
//                 endgpList.Append(gp);
	}
    }

//     if (endgpList.GetCount() > 0)
//     {
//         endgpList.ToHead();
//         while (1)
// 	{
//             (endgpList.Get())->Number(number++);
//             if (endgpList.ToNext() == NO) break;
// 	}
//     }

    // ƻήϿ줿ꥹȤϿξϡƻ̵֤
    // ȤơȤʤ
    // ƻήϿ줿ꥹȤϿ̤ξϥ顼
    if (rspList.GetCount() == 0) { }
    else if (rspList.GetCount() < 4) { error(); abort(); }
    else
    {
        rspList.ToHead();
        while (1)
	{
            RiversidePoint0* rsp = rspList.Get();
            GridPoint3d* gp = rsp->Gpoint();
            if (gp != NULL)
	    {
                gp->Number(number++);
	    }
            if (rspList.ToNext() == NO) break;
	}
    }

    // ήβ³ե˽Ϥ
    ofstream output1(fname1);
    if (!output1)
    {
        cerr << "Cannot open " << fname1 << endl;
        error(); abort();
    }
//      output1 << "# ֹ xɸ(m) yɸ(m) zɸ(m) (m2) "
//              << "ƻήȽ ³ ³Ƥֹ\n"
//              << "# () ƻήȽ  1:ƻή  "
//              << "0:ƻήǤϤʤ\n"
//              << "# () ֺǽο\n";
    output1 << "# This data was generated by temporaryConnect " << Version() << endl;
    output1 << "# ֹ xɸ(m) yɸ(m) zɸ(m) (m2) "
            << "μ ³ ³Ƥֹ\n"
            << "# (1) μ  -1:ɸͤͿƤΰü˰֤  "
            << "0:ή  ο:ƻ⤷ϲƻή\n"
            << "# (2) ֺǽο\n";

    output1 << number - 1 << "\n";
    //  for (ir = 0; ir < rowval; ir++)
    for (int ir = 0; ir < rowval; ir++)
    {
        for (int ic = 0; ic < colval; ic++)
	{
            GridPoint3d* gp = grid(ir, ic);
            if (gp != NULL && gp->RiverFlag() == 0)
	    {
                output1 << setw(8) << gp->Number() << " "
                        << setw(8) << gp->x() << " "
                        << setw(8) << gp->y() << " "
                        << setw(15) << gp->z() << " "
                        << setw(15) << gp->Area() << " ";
                if (gp->EdgeFlag() == 1)
                    output1 << setw(6) << -1 << " ";
                else
                    output1 << setw(6) << 0 << " ";
	      
                output1 << setw(3) << gp->CntNum();
                DList<GridPoint3d*>& ngpList = gp->NeighborGp();
                if (ngpList.GetCount() > 0)
		{
                    ngpList.ToHead();
                    while (1)
		    {
                        GridPoint3d* ngp = ngpList.Get();
                        output1 << setw(8) << ngp->Number() << " ";
                        if (ngpList.ToNext() == NO) break;
		    }
		}
                output1 << "\n";
	    }
	}
    }

//     if (endgpList.GetCount() > 0)
//     {
//         endgpList.ToHead();
//         while (1)
// 	{
//             GridPoint3d* gp = endgpList.Get();

//             output1 << setw(8) << gp->Number() << " "
//                     << setw(8) << gp->x() << " "
//                     << setw(8) << gp->y() << " "
//                     << setw(15) << gp->z() << " "
//                     << setw(15) << gp->Area() << " ";
//             if (gp->RiverFlag() < 0)
//                 output1 << setw(6) << (gp->RiverFlag()) * (-1) << " ";
//             else
//                 output1 << setw(6) << gp->RiverFlag() << " ";

//             output1 << setw(3) << gp->CntNum() << " ";
//             DList<GridPoint3d*>& ngpList = gp->NeighborGp();
//             if (ngpList.GetCount() > 0)
// 	    {
//                 ngpList.ToHead();
//                 while (1)
// 		{
//                     GridPoint3d* ngp = ngpList.Get();
//                     output1 << setw(8) << ngp->Number() << " ";
//                     if (ngpList.ToNext() == NO) break;
// 		}
// 	    }

//             output1 << "\n";

//             if (endgpList.ToNext() == NO) break;
// 	}
//     }


    // ƻήϿ줿ꥹȤϿξϡƻ̵֤
    // Ȥơե close  return 
    if (rspList.GetCount() == 0) 
    { output1.close();  return; }
    rspList.ToHead();
    while (1)
    {
        RiversidePoint0* rsp = rspList.Get();
        GridPoint3d* gp = rsp->Gpoint();
        if (gp != NULL)
	{
            output1 << setw(8) << gp->Number() << " "
                    << setw(8) << gp->x() << " "
                    << setw(8) << gp->y() << " "
                    << setw(8) << gp->z() << " "
                    << setw(8) << gp->Area() << " ";
            if (gp->RiverFlag() < 0)
                output1 << setw(6) << (gp->RiverFlag()) * (-1) << " ";
            else
                output1 << setw(6) << gp->RiverFlag() << " ";

            output1 << setw(3) << gp->CntNum() << " ";
            DList<GridPoint3d*>& ngpList = gp->NeighborGp();
            if (ngpList.GetCount() > 0)
	    {
                ngpList.ToHead();
                while (1)
		{
                    GridPoint3d* ngp = ngpList.Get();
                    output1 << setw(8) << ngp->Number() << " ";
                    if (ngpList.ToNext() == NO) break;
		}
	    }
            output1 << "\n";
	}

        if (rspList.ToNext() == NO) break;
    }

    output1.close();
    return;
}

// ********************************************************************
void
CheckCntPrint(		// ³ɸϤ
              Grid<GridPoint3d*>& grid, // åɤĺ
              DList<RiversidePoint0*>& rspList // ƻήꥹ
              )
{
    cout << "-------- Print Connect Check ----------" << endl;

    int rowval = grid.GetRows();
    int colval = grid.GetCols();
    for (int ir = 0; ir < rowval; ir++)
    {
        for (int ic = 0; ic < colval; ic++)
	{
            GridPoint3d* gp = grid(ir, ic);
            if (gp != NULL)
	    {
                cout << "(" << gp->x() << " " << gp->y() << " "
                     << gp->z() << ")(" << gp->RiverFlag()
                     << ") (" 
                     << gp->Area() 
                     << ") ("
                     << gp->CntNum() << ")\t";
                int check = 0;
                DList<GridPoint3d*>& ngpList = gp->NeighborGp();
                if (ngpList.GetCount() > 0)
		{
                    ngpList.ToHead();
                    while (1)
		    {
                        GridPoint3d* ngp = ngpList.Get();
                        cout << setw(8) << ngp->z() << " ";
                        check++;
                        if (ngpList.ToNext() == NO) break;
		    }
		}
                cout << endl;

                if (check != gp->CntNum())
		{ error(); abort(); }
                if (gp->RiverFlag() > 0 && gp->CntNum() > 0)
		{ error(); abort(); }

	    }
	}
    }

    // ƻήϿ줿ꥹȤϿξϡƻ̵֤
    // ȤơȤ return 
    // ƻήϿ줿ꥹȤϿ̤ξϥ顼
    if (rspList.GetCount() == 0) { return; }
    else if (rspList.GetCount() < 4) { error(); abort(); }

    rspList.ToHead();
    while (1)
    {
        RiversidePoint0* rsp = rspList.Get();
        GridPoint3d* gp = rsp->Gpoint();
        if (gp != NULL)
	{
            cout << "(" << gp->x() << " " << gp->y() << " "
                 << gp->z() << ")(" << gp->RiverFlag()
                 << ") ("
                 << gp->Area() 
                 << ") ("
                 << gp->CntNum() << ")\t";
            int check = 0;
            DList<GridPoint3d*>& ngpList = gp->NeighborGp();
            if (ngpList.GetCount() > 0)
	    {
                ngpList.ToHead();
                while (1)
		{
                    GridPoint3d* ngp = ngpList.Get();
                    cout << setw(8) << ngp->z() << " ";
                    check++;
                    if (ngpList.ToNext() == NO) break;
		}
	    }
            cout << endl;

            if (check != gp->CntNum())
	    { error(); abort(); }

	}

        if (rspList.ToNext() == NO) break;
    }
    return;
}

// ********************************************************************
// ----- main ؿ -----
int main(int argc, char* argv[])
{
    if (argc != 1 && argc != 2) { 
        cerr << "usage: " << argv[0] 
             << " InputDataFile "
             << endl; 
        exit(1);
    }

    char* fname;
    char filename[TOTALFILES][BUFFLEN];
    if (argc == 1) {
        cout << "Input file name : ";
        cin >> fname;
        dfstream input0(fname);
        if(!input0) {
            cerr << "Cannot open " << fname << endl; exit(1);
        }
        for (int ith = 0; ith < TOTALFILES; ith++) {
            char fnames[BUFFLEN];
            input0.getline(fnames, BUFFLEN);
            //istrstream ifnames(fnames);    // comment out Oct. 11, 2007
            istringstream ifnames((const char*)fnames);   // added Oct. 11, 2007
            ifnames >> filename[ith];
        }
        input0.close();
    }
    else {
        dfstream input0(argv[1]);
        if(!input0) {
            cerr << "Cannot open " << argv[1] << endl; exit(1);
        }
        for (int ith = 0; ith < TOTALFILES; ith++) {
            char fnames[BUFFLEN];
            input0.getline(fnames, BUFFLEN);
            //istrstream ifnames(fnames);    // comment out Oct. 11, 2007
            istringstream ifnames((const char*)fnames);   // added Oct. 11, 2007
            ifnames >> filename[ith];
        }
        input0.close();
    }
 
    // 1.ɸǡ

    cout << "1. Reading of Grid Data: " ;

    dfstream input1(filename[0]);
    if(!input1) {
        cerr << "Cannot open " << filename[0] << endl;
        exit(1);
    }
  
    char str0[BUFFLEN];
    input1.getline(str0, BUFFLEN);
  
    int row, col;
    //istrstream istr0(str0);    // comment out Oct. 11, 2007
    istringstream istr0((const char*)str0);   // added Oct. 11, 2007
    istr0 >> row >> col;
    if (!istr0) { error(); abort(); }
  
    Grid<GridPoint3d*> grid(row + 2, col + 2);
    // åɤ NULL ʤ
    // grid.Fill(NULL);
    grid.Fill((GridPoint3d*)NULL);
  
    int totalpoint = 0;	// Ϥ
    while (1)
    {
        int numVal, mVal, nVal;
        Metric xVal, yVal; 
        ElvType zVal;
        char str[BUFFLEN];
      
        input1.getline(str, BUFFLEN);
        if (!input1) break;
        //istrstream istr(str);   // comment out Oct. 11, 2007
        istringstream istr((const char*)str);   // added Oct. 11, 2007
        istr >> numVal >> xVal >> yVal >> zVal >> mVal >> nVal;
        if (!istr)
	{
            totalpoint++;
            cerr << "line: " << totalpoint << "; Not enough data items. "
                 << endl;
            abort();
	}
      
        GridPoint3d* gpp = new GridPoint3d;
        assert(gpp != NULL);
      
        gpp->Number(numVal);
        gpp->SetVal(xVal, yVal, zVal);
      
        if (grid(mVal, nVal) == NULL)
            grid(mVal, nVal) = gpp;
        else 
	{ error(); abort(); }
      
        totalpoint++;
    }
  
    input1.close();

    cout << "Done." << endl;
  
    // 2.åɥݥȤβ³

    cout << "2. Temporal Connection of Grid Points: " ;
  
    int rowval = grid.GetRows();
    int colval = grid.GetCols();
  
    for (int i = 0; i < rowval; i++)
    {
        for (int j = 0; j < colval; j++)
	{
            if (grid(i, j) != NULL)
	    {
                int chk = 0;
                if (grid(i - 1, j + 1) != NULL && 
                    grid(i - 1, j) != NULL && grid(i, j + 1) != NULL) 
		{ grid(i, j)->ConnectGp(grid(i - 1, j + 1)); 
                chk++; /* ³ */ }
                if (grid(i - 1, j) != NULL)
		{ grid(i, j)->ConnectGp(grid(i - 1, j));
                chk++; /* ³ */ }
                if (grid(i - 1, j - 1) != NULL &&
                    grid(i, j - 1) != NULL && grid(i - 1, j) != NULL)
		{ grid(i, j)->ConnectGp(grid(i - 1, j - 1));
                chk++; /* ³ */ }
                if (grid(i, j - 1) != NULL)
		{ grid(i, j)->ConnectGp(grid(i, j - 1));
                chk++; /* ³ */ }
                if (grid(i + 1, j - 1) != NULL &&
                    grid(i + 1, j) != NULL && grid(i, j - 1) != NULL)
		{ grid(i, j)->ConnectGp(grid(i + 1, j - 1));
                chk++; /* ³ */ }
                if (grid(i + 1, j) != NULL)
		{ grid(i, j)->ConnectGp(grid(i + 1, j));
                chk++; /* ³ */ }
                if (grid(i + 1, j + 1) != NULL &&
                    grid(i, j + 1) != NULL && grid(i + 1, j) != NULL)
		{ grid(i, j)->ConnectGp(grid(i + 1, j + 1));
                chk++; /* ³ */ }
                if (grid(i, j + 1) != NULL) 
		{ grid(i, j)->ConnectGp(grid(i, j + 1));
                chk++; /* ³ */ }
                if (chk < 8)
                    grid(i, j)->EdgeFlag(1);
	    }
	}
    }

    cout << "Done." << endl;
  
    // 3.ƻ֥ǡ

    cout << "3. Reading of River Network Data: " ;

    RiverElmnt re;
    re.SetDataWithGrid(filename[1]);
    re.RemakeNumber();

    cout << "Done." << endl;
  
    // 4.ƻΥåɥݥȤ³

    cout << "4. Cut of the Connections around the Network: " ;

    DList<NodeL*>& nodeList = re.NodeLpList();
    DList<Rseg*>& rsegList = re.RsegpList();

    // ƻ֤ξƻֹĤǽ
    OutputNewriver(filename[3], nodeList, rsegList);

    if (rsegList.GetCount() == 0) { }
    else
    {
        rsegList.ToHead();
        while (1)
        {
            Rseg* tmprseg = rsegList.Get();
	  
            DList<RiverPoint*>& rpList = tmprseg->StrmpList();
	  
            if (rpList.GetCount() == 0) { error(); abort(); }
	  
            int premval = -1;	// γʻxɸ
            int prenval = -1;	// γʻyɸ
            rpList.ToHead();
            while (1)
            {
                RiverPoint* tmprp = rpList.Get();
                int mval = tmprp->MGB();
                int nval = tmprp->NGB();
	      
                //                cout << mval << " " << nval << endl;

                if (grid(mval - 1, nval + 1) != NULL) /* ³ڤ */
                { 
                    if (grid(mval, nval) != NULL)
                        grid(mval, nval)->CutGp(grid(mval - 1, nval + 1)); 
                    grid(mval - 1, nval + 1)->CutGp(grid(mval, nval)); 
                }
                if (grid(mval - 1, nval) != NULL)     /* ³ڤ */ 
                { 
                    if (grid(mval, nval) != NULL)
                        grid(mval, nval)->CutGp(grid(mval - 1, nval)); 
                    grid(mval - 1, nval)->CutGp(grid(mval, nval)); 
                }
                if (grid(mval - 1, nval - 1) != NULL) /* ³ڤ */
                { 
                    if (grid(mval, nval) != NULL)
                        grid(mval, nval)->CutGp(grid(mval - 1, nval - 1)); 
                    grid(mval - 1, nval - 1)->CutGp(grid(mval, nval)); 
                }
                if (grid(mval, nval - 1) != NULL)     /* ³ڤ */
                { 
                    if (grid(mval, nval) != NULL)
                        grid(mval, nval)->CutGp(grid(mval, nval - 1)); 
                    grid(mval, nval - 1)->CutGp(grid(mval, nval));
                }
                if (grid(mval + 1, nval - 1) != NULL) /* ³ڤ */
                { 
                    if (grid(mval, nval) != NULL)
                        grid(mval, nval)->CutGp(grid(mval + 1, nval - 1)); 
                    grid(mval + 1, nval - 1)->CutGp(grid(mval, nval)); 
                }
                if (grid(mval + 1, nval) != NULL)     /* ³ڤ */
                { 
                    if (grid(mval, nval) != NULL)
                        grid(mval, nval)->CutGp(grid(mval + 1, nval)); 
                    grid(mval + 1, nval)->CutGp(grid(mval, nval)); 
                }
                if (grid(mval + 1, nval + 1) != NULL) /* ³ڤ */
                { 
                    if (grid(mval, nval) != NULL)
                        grid(mval, nval)->CutGp(grid(mval + 1, nval + 1)); 
                    grid(mval + 1, nval + 1)->CutGp(grid(mval, nval)); 
                }
                if (grid(mval, nval + 1) != NULL)     /* ³ڤ */
                { 
                    if (grid(mval, nval) != NULL)
                        grid(mval, nval)->CutGp(grid(mval, nval + 1)); 
                    grid(mval, nval + 1)->CutGp(grid(mval, nval)); 
                }
	      
                // ƻշгǤäΥåɥݥȤ
                // ³
                if (premval == mval - 1 && prenval == nval + 1)
                { /* ³ڤ */
                    if (grid(mval - 1, nval) != NULL)
                        grid(mval - 1, nval)->CutGp(grid(mval, nval + 1)); 
                    if (grid(mval, nval + 1) != NULL)
                        grid(mval, nval + 1)->CutGp(grid(mval - 1, nval)); 
                }
                if (premval == mval - 1 && prenval == nval - 1)
                { /* ³ڤ */
                    if (grid(mval - 1, nval) != NULL)
                        grid(mval - 1, nval)->CutGp(grid(mval, nval - 1)); 
                    if (grid(mval, nval - 1) != NULL)
                        grid(mval, nval - 1)->CutGp(grid(mval - 1, nval)); 
                }

                if (premval == mval + 1 && prenval == nval - 1)
                { /* ³ڤ */
                    if (grid(mval + 1, nval) != NULL)
                        grid(mval + 1, nval)->CutGp(grid(mval, nval - 1)); 
                    if (grid(mval, nval - 1) != NULL)
                        grid(mval, nval - 1)->CutGp(grid(mval + 1, nval)); 
                }
                if (premval == mval + 1 && prenval == nval + 1)
                { /* ³ڤ */
                    if (grid(mval + 1, nval) != NULL)
                        grid(mval + 1, nval)->CutGp(grid(mval, nval + 1)); 
                    if (grid(mval, nval + 1) != NULL)
                        grid(mval, nval + 1)->CutGp(grid(mval + 1, nval)); 
                }
	      
                premval = mval;  prenval = nval;
                if (rpList.ToNext() == NO) break;
            }
            if (rsegList.ToNext() == NO) break;
        }
    }

    cout << "Done." << endl;

//  // 5.ƻήƳ
//  SListDynamic<RiverPoint*> chaseList;
//  RiverChase0(nodeList, chaseList);
//  cout << "work5.1 finished" << endl;

//  DList<RiversidePoint0*> rspList;
//  RiversideWork(grid, chaseList, rspList);
//  cout << "work5.2 finished" << endl;

    // 5. ƻήƳ

    cout << "5. Setting of River Side Points: " ;
  
    DList<RiversidePoint0*> rspList;
    DList<RivUnit*> rivunitList;       // ƻȲƻĤʤ˥åȤΥꥹ
    RiverChase(grid, rsegList, rspList, rivunitList);

    cout << "Done." << endl;

    // added by Yutaka ICHIKAWA (Thu Sep  3 17:32:02 1998)
    // for debugging
    // from here

    /* 
    ofstream tmpfile("rspfile");
    rspList.ToHead(); 
    do
    {
	RiversidePoint0* wp = rspList.Get();
 	tmpfile << wp->MGB() << " " << wp->NGB() << endl;
    }
    while (rspList.ToNext() == YES) ;
    tmpfile.close();

    ofstream tmpfile2("rivunitfile");
    rivunitList.ToHead();
    do
    {
	RivUnit* p = rivunitList.Get();
        RiverPoint p1 = p->p1Val();
        RiverPoint p2 = p->p2Val();
 	tmpfile2 << p1.x() << " " << p1.y() << endl;
 	tmpfile2 << p2.x() << " " << p2.y() << endl;
        tmpfile2 << endl;
    }
    while (rivunitList.ToNext() == YES) ;
    tmpfile2.close();
    */

//     // 6.ƻήήβ³
//     CntRiversideGp(grid, rspList);
//     cout << "work6 finished" << endl;

    // 6.ƻήήβ³

    cout << "6. Temporal Connections between Grid Points and River Side Points: " ;
    CntRiversideGp(grid, rspList, rivunitList);
    cout << "Done." << endl;
  
    // ----- gnuplot  -----
    GnuDataPrint(filename[4], grid, rspList);
  
     // 7.ήѤη׻
//      CalcArea(grid, rspList);
    cout << "7. Calculation of Area of each Point: " ;
    CalcArea(grid, rspList, nodeList);
    cout << "Done." << endl;

    // 8.ήβ³ե˽
    cout << "8. Writing the Temporal Connection File: " ;
    OutputTmpCntData(grid, rspList, filename[2]);
    cout << "Done." << endl;

    return 0;
}
 
/*; end of file */
