/*;  node.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl node.h\quad\thepage}} */
/*;  $$Date: 1997/03/01 21:18:34 $$  */
/*;  $$Source: /home/sakakiba/96prog/slope/node.h,v $$  */


#if !defined(node_h)
#define node_h

#include "geometrc.h"
#include "rseg.h"
#include "node.h"
#include "dlist.h"
#include "dlist.cc"

class Rseg;

// 饹
/* ȤϲƻʬξüΤȤǤֹ桢x,y,z ɸ*/
/* Ȥ³ƤƻʬΥݥ󥿤ΥꥹȤäƤޤ*/
class NodeL : public Point3d, public DList<Rseg*>
{
    // added by iYutaka (Wed Nov 13 18:20:33 2002)
    // ʻ x, y ɸǡФ˲äޤ

    int mGB, nGB;

 public:

    // default constructor
    NodeL() {}

    // copy constructor 
    NodeL(NodeL& node):Point3d(node), DList<Rseg*>(node) {}

    NodeL(Metric xVal, Metric yVal, ElvType zVal, long nVal = 0)
    {
	SetVal(xVal, yVal, zVal, nVal);
    }

    // mod. by iYutaka (Wed Nov 13 18:22:41 2002)
    NodeL(Metric xVal, Metric yVal, ElvType zVal, 
          int amGB, int anGB, long nVal = 0)
    {
	SetVal(xVal, yVal, zVal, amGB, anGB, nVal);
    }

    NodeL& operator= (const NodeL& node) // assignment operator
    {
        if (&node == this)  return *this;
	Point3d::operator=((Point3d)node);
	DList<Rseg*>::operator=(node);
        return *this;
    }

    void SetVal(Metric xVal, Metric yVal, ElvType zVal, long nVal = 0)
    {
	xd = xVal;  yd = yVal;  zd = zVal;  nd = nVal;
    }

    // added by iYutaka (Wed Nov 13 18:21:15 2002)
    void SetVal(Metric xVal, Metric yVal, ElvType zVal, 
                int amGB, int anGB, long nVal = 0)
    {
	xd = xVal;  yd = yVal;  zd = zVal;  
        mGB = amGB; nGB = anGB;
        nd = nVal;
    }

    // added by iYutaka (Wed Nov 13 18:31:26 2002)
    int MGB(void) { return mGB; }
    int NGB(void) { return nGB; }

};

#endif

/*; end of file */
